{-

APS
(C) Copyright Omar Almousa 2014-2015

All Rights Reserved.

-}
-- module Main where
module Analyze where  
import ComposeM
import Msg
import StrandAST
import Data.List
import Data.Maybe

-- 1)A Symmetric: if we "receive" key and we have the encrypted message then we add the message if we do not have it
--analyze:: SKnowledge-> (SKnowledge, ([Strand0->Strand0]))
analyze csc wl k = analyze0 100 k [] csc wl
---------------------------------------------------------------
analyze0:: Integer -> SKnowledge -> SKnowledge-> [Strand0->Strand0] -> SKnowledge-> (SKnowledge, [Strand0->Strand0],SKnowledge )
analyze0 n [] done csc wl = (done,csc, wl)
analyze0 0 k done csc wl = if((k\\wl)==[]) then (done,csc, wl) else error ("??"++show (k,done, wl))
analyze0 n k@(x:xs) done csc wl=  if((k\\wl)==[]&& n<50) then (done,csc, wl) 
                                    else if (not(elem x wl) && not(elem x done)) then analyze0 (n-1) xs (x:done) csc wl
                                    else if (not(elem x wl) && (elem x done)) then analyze0 (n-1) xs (done) csc wl
                                    else -- union
                                    let result = (analyzeK ((k ++ done)) x) in
                                        case (fst' result) of 
                                        1 -> analyze0 (n-1) (xs) (x:done) (csc++(trd' result)) (wl\\[x])
                                        2 -> analyze0 (n-1) ((snd' result) ++ xs ) (x:done) (csc++(trd' result)) ((snd' result) ++(wl\\[x]))-- formats
                                        3 -> analyze0 (n-1) ((snd' result) ++ xs ) (x:done) (csc++(trd' result)) ((snd' result) ++(wl\\[x]))-- crypt and key is composable 1 and sign
                                        4 -> analyze0 (n-1) ((xs++ (snd' result))) (done) (csc++(trd' result)) (wl)-- crypt and key not composable!
-- 1) messages that can't be further decomposed plus formats!
-- needs improvement in the sense that if we find many!
analyzeK k lmsg@(l,Atom x)= (1,[lmsg], r) 
                                where     m= snd lmsg;
                                          k' = k\\[lmsg];
                                          r = if(composable k' m) then ([V Check l (composE k' m)]) else []
analyzeK k lmsg@(l,Comp Hash opt x)= (1,[lmsg], r) 
                                where     m= snd lmsg;
                                          k' = k\\[lmsg];
                                          r = if(composable k' m) then ([V Check l (composE k' m)]) else []
analyzeK k lmsg@(l,Comp Mac opt x)= (1,[lmsg], r) 
                                where     m= snd lmsg;
                                          k' = k\\[lmsg];
                                          r = if(composable k' m) then ([V Check l (composE k' m)]) else []
analyzeK k lmsg@(l,Comp Inv opt x)= (1,[lmsg], r) 
                                where     m= snd lmsg;
                                          k' = k\\[lmsg];
                                          r = if(composable k' m) then ([V Check l (composE k' m)]) else []
analyzeK k lmsg@(l,Comp Shk opt x)= (1,[lmsg], r) 
                                where     m= snd lmsg;
                                          k' = k\\[lmsg];
                                          r = if(composable k' m) then ([V Check l (composE k' m)]) else []
analyzeK k lmsg@(l,Comp Pk opt x)= (1,[lmsg], r) 
                                where     m= snd lmsg;
                                          k' = k\\[lmsg];
                                          r = if(composable k' m) then ([V Check l (composE k' m)]) else []
-- PbK and PbV
analyzeK k lmsg@(l,Comp PbK opt x)= (1,[lmsg], r) 
                                where     m= snd lmsg;
                                          k' = k\\[lmsg];
                                          r = if(composable k' m) then ([V Check l (composE k' m)]) else []
analyzeK k lmsg@(l,Comp PvK opt x)= (1,[lmsg], r) 
                                where     m= snd lmsg;
                                          k' = k\\[lmsg];
                                          r = if(composable k' m) then ([V Check l (composE k' m)]) else []
-- Pub -- nor private version of this!
analyzeK k lmsg@(l,Comp Pub opt x)= (1,[lmsg], r) 
                                where     m= snd lmsg;
                                          k' = k\\[lmsg];
                                          r = if(composable k' m) then ([V Check l (composE k' m)]) else []
-- TODO Paolo added this
analyzeK k lmsg@(l,Comp Sk opt x)= (1,[lmsg], r) 
                                where     m = snd lmsg;
                                          k' = k\\[lmsg];
                                          r = if(composable k' m) then ([V Check l (composE k' m)]) else []

-- then (1,(compose k (snd lmsg)),r) 
-- where r = if (length (compose k (snd lmsg))>1) then (map (V Check l) (compose k (snd lmsg))) else []
-- 2) exp and mult need more details:
--         a case where for nesting to match the shorten case of analyze, 
--         another case if the subterms are just atomic (nothing to do)
--         any other case/s
analyzeK k lmsg@(l,Comp Exp opt x)= (1,[lmsg], r) 
                                where     m= snd lmsg;
                                          k' = k\\[lmsg];
                                          r = if(composable k' m) then ([V Check l (composE k' m)]) else []
analyzeK k lmsg@(l,Comp Mult opt x)= (1,[lmsg], r) 
                                where   m= snd lmsg;
                                        k' = k\\[lmsg];
                                        r = if(composable k' m) then ([V Check l (composE k' m)]) else []
-- 3) mappings, formats or what else (maybe a user defined functions!)
-- analyzeK k lmsg@(l,Comp Apply [x,(Comp Cat xs)])=     if (elem x mappings) then (1,[lmsg],r) -- if it is not any of above, then it is a format that we just append all of its sub-messages that are not already there into our knowledge
analyzeK k lmsg@(l,Comp Apply opt ((Atom x):xs))=  if (isMapping x) then (1,[lmsg],r) 
                                                        else if (isFormat x) then (2,(labelMsgList xs ((length k))),r') else (1,[lmsg],r) 
                    -- append all of its sub-messages that are not already there into our knowledge

            where   m= snd lmsg;
                    k' = k\\[lmsg];
                    r = if(composable k' m) then (map (V Check l) (compose k' m)) else [];
                    r' = (V Vformat (Atom x) l): (hows l (Atom x)  (labelMsgList  xs ((length k))))
{-                                          -- else if (elem x formats) 
                                            -- then (2,(labelMsgList xs ((length k))),r')
                                         -- then (2,(labelMsgList (filter (notComp k) xs) ((length k))),r')
    else error("Unrecognized operator "++show(x)++", it is not a format, a mapping, a predefined-function, nor a user-defined function\n\n")   
-}                    
-- 3.A) MAPPINGS: Nothing to do (no decompose)
-- 3.B) FORMATS, if any of the subterms in a format is not composable, then it will be:
-- filtered out, labelled and added to the knowledge

-- 4) messages that can be decomposed (not including formats, they are included in previous case- else of last)
-- this condition ((compose k msg/=[])) must be added to generateOperationalStrands
-- 4.A) Symmetric Encryption
-- analyzeK k lmsg@(l,Comp Scrypt [key, m])= if([composE k key]/=[]) then (3,[((giveMeLabel k 1), m)],r)    
analyzeK k lmsg@(l,Comp Scrypt opt [key, m])= if(composable k key) then (3,[((giveMeLabel k 1), m)],r)    
                                            else (4, [lmsg], [])
                                        where r = [V Vscrypt (composE k key) l, How Sdecrypt (giveMeLabel k 1) (composE k key) l]
-- 4.B1) Asymmetric Encryption with pbk/pvk --TODO: checks?
-- analyzeK k lmsg@(l,Comp Crypt opt [Comp PbK [] [n], m])= if(composable  k (Comp PvK [] [n]) ) then (3,[((giveMeLabel k 1), m)],r)
                                            -- else (4, [lmsg],[])
                                        -- where r = [V Vcrypt (composE k (Comp PvK [] [n])) l, How Decrypt (giveMeLabel k 1) (composE k (Comp PvK [] [n])) l];
-- 4.B2) Asymmetric Encryption with Pub 
analyzeK k lmsg@(l,Comp Crypt opt [Comp Pub [] [n], m])= if(composable  k n ) then (3,[((giveMeLabel k 1), m)],r)
                                            else (4, [lmsg],[])
                                        where r = [V Vcrypt (composE k n) l, How Decrypt (giveMeLabel k 1) (composE k n) l];
-- 4.B3) Asymmetric Encryption with pk/inv
analyzeK k lmsg@(l,Comp Crypt opt [key, m])= if(composable  k (Comp Inv [] [key]) ) then (3,[((giveMeLabel k 1), m)],r)
                                            else (4, [lmsg],[])
                                        where r = [V Vcrypt (composE k (Comp Inv [] [key])) l, How Decrypt (giveMeLabel k 1) (composE k (Comp Inv [] [key])) l];

-- 4.C1) Sign (inv)
-- Signed by others or signed by myself!
analyzeK k lmsg@(l,Comp Sign opt1 [Comp Inv opt2 [key], m])= if (composable k key) then (3, [((giveMeLabel k 1), m)], r)
                                                    else (4,[lmsg],[])
                                                where r=[V Vsign (composE k key) l, How Open (giveMeLabel k 1) (composE k key) l ]
-- 4.C2) Sign (pvk)
-- Signed by others or signed by myself!
analyzeK k lmsg@(l,Comp Sign opt1 [Comp PvK opt2 [n], m])= if (composable k (Comp PbK [] [n])) then (3, [((giveMeLabel k 1), m)], r)
                                                    else (4,[lmsg],[])
                                                where r=[V Vsign (composE k (Comp PbK [] [n])) l, How Open (giveMeLabel k 1) (composE k (Comp PbK [] [n])) l ]
-- 4.C3) Sign (atomic private key-- no pvk nor inv!)
-- Signed by others or signed by myself!
analyzeK k lmsg@(l,Comp Sign opt1 [prvK, m])= if (composable k (Comp Pub [] [prvK])) then (3, [((giveMeLabel k 1), m)], r)
                                                    else (4,[lmsg],[])
                                                where r=[V Vsign (composE k (Comp Pub [] [prvK])) l, How Open (giveMeLabel k 1) (composE k (Comp Pub [] [prvK])) l ]
-- 4.D) Sign (no Inv)
{- this needs a property on pk
--analyzeK k lmsg@(l,Comp Sign [key, m])= if (composable k (Comp Inv [key])) then (3,[((giveMeLabel k 1), m)], r)
                                         else (4,[lmsg],[])
                                        where r=[V Vsign (composE k key) l, How Open (giveMeLabel k 1) (composE k key) l ]
                                                -- else (1,[],[Check l (Comp Sign [(Atom "TRUE"), (composE k m)])])
-}
-- 4.C1) SignH (inv)
-- Signed by others or signed by myself!
analyzeK k lmsg@(l,Comp FsignH opt0 [s@(Comp SignH opt1 [Comp Inv opt2 [key], Comp Hash opt3 [m]])])= if (composable k key) then (3, [((giveMeLabel k 1), m)], r)
                                                    else (4,[lmsg],[])
                                                where r=[V VFsignH m l , How GetSignH (giveMeLabel k 1) (composE k key) l, V (VSignH m) (composE k key) s]
-- 4.C2) SignH (pvk)
-- Signed by others or signed by myself!
analyzeK k lmsg@(l,Comp FsignH opt0 [s@(Comp SignH opt1 [Comp PvK opt2 [n], Comp Hash opt3 [m]])])= if (composable k (Comp PbK [] [n])) 
                                                                                                        then (3, [((giveMeLabel k 1), m)], r)
                                                                                                        else (4,[lmsg],[])
                                   where r=[V VFsignH m l , How GetSignH (giveMeLabel k 1) (composE k (Comp PbK [] [n])) l, V (VSignH m) (composE k (Comp PbK [] [n])) s]
-- 4.C3) SignH (pub)
-- Signed by others or signed by myself!
analyzeK k lmsg@(l,Comp FsignH opt0 [s@(Comp SignH opt1 [prvK, Comp Hash opt3 [m]])])= if (composable k (Comp Pub [] [prvK])) 
                                                                                                        then (3, [((giveMeLabel k 1), m)], r)
                                                                                                        else (4,[lmsg],[])
                                   where r=[V VFsignH m l , How GetSignH (giveMeLabel k 1) (composE k (Comp Pub [] [prvK])) l, V (VSignH m) (composE k (Comp Pub [] [prvK])) s]
-- 4.E) "ugly" Cat
analyzeK k lmsg@(l,Comp Cat opt xs)= (2,(labelMsgList xs (length k)), r)
                                    where r = catHows 1 l (labelMsgList xs (length k))
analyzeK k lmsg= error("Unknown Message:\n"++ show(snd lmsg)++"\n\n From this knowledge:\n"++ show(k))
---------------------------------------------------------------------
formats=[] 
mappings = [] 
--------------------------------------------------------------------------
-- supporting functions:
-- generates a label for a new message/term
giveMeLabel [] _= error "are you kidding! The agent knows nothing?!"
-- giveMeLabel k n= Atom ("X" ++ show((length k) + 1+ n))
giveMeLabel k n= Atom ("X" ++ show((length k) + n))
---------------------------------------------------------------------
---------------------------------------------------------------------
isFormat ('f':'r':'m':rst) = True
isFormat  _ = False
---------------------------------------------------------------------
isMapping ('m':'p':'p':rst) = True
isMapping  _ = False
---------------------------------------------------------------------
isUserDefFun ('u':'d':'f':rst) = True
isUserDefFun  _ = False
---------------------------------------------------------------------
-------------------------------------------------------------------
----------------------------------------------------------------
-- same as createLabel of generatePlainStrands.hs :)
createALabel (a,b)= a ++ show(b) 
-- similar to labelKnowledge of generatePlainStrands.hs, but not the same!
-- this is a more generic version
labelMsgList [] n = [] --error "are you kidding me! A format is formatting nothing?!?!"
labelMsgList x 0 = error "are you kidding me! A format is formatting nothing?!?!" 
labelMsgList x n = zip (map Atom (map createALabel (zip (take (length x) (repeat "X")) (take (length x) [(n+1)..])))) x    
-- Tuple handlers
-- fst'(a,_,_)=a
-- snd'(_,b,_)=b
-- trd'(_,_,c)=c
--- just counting
ecount x l= length (filter (x ==) l)
-- takes a list of Strand0->Strand0 and return a Strand0
combineAll [] = Connects -- \s -> s --EOS "Hello"
combineAll (x:xs)= (x) . (combineAll xs)
----------- takes a list of Strand0->Strand0 and return a Strand
-- combineToStr [] = EOS "Hello"
-- combineToStr (x:xs)= (x) . (combineToStr xs)
-- hows: takes the size of a knowledge to label the new created object, and the rest are explained in hows0 
-- hows0: takes a number (getter order), formatName, formatted message label and a list of labelled messages extraxted from the formatted message and produces  how these messages were produced
hows  _ _ []  = []
hows   frmLbl frmName sbTrms= (Create (relabel frmLbl) frmLbl frmName ) : (hows0 1 frmName (relabel frmLbl) sbTrms)
hows0  n _ _ []  = []
-- if you decide to add an "a" before ".get" in "toJava.hs" then remove the second call of relabel above
hows0 n frmName frmLbl sbTrms@((l,msg):lbldElmnts)= (How (Get n)  l frmName frmLbl) : (hows0 (n+1) frmName frmLbl lbldElmnts)
relabel (Atom x) = (Atom x)--(Atom (x++ "a"))
------- how version for Concatenation
catHows _ _ []= []
catHows n catLbl sbTrms@((l,msg):lbldElmnts) = (How (Project n) l catLbl l): catHows (n+1) catLbl lbldElmnts
--------------

-- main = do
        -- let oKnows=[(Atom "X1", Atom "k")]
        -- let c=analyzeK oKnows (Comp Scrypt [Atom "k", Atom "m"], (Atom "X1", Atom "k"))
        -- let ook = [(Atom "X1",Comp Sign [Comp Inv [Atom "k1"], Atom "k"]),(Atom "X2",Atom "hi")]
        --let ook = [(Atom "X1",Comp Sign [Atom "k1", Atom "k"]),(Atom "X2",Comp Scrypt [Atom "k",Atom "m"])]
        -- let ook = [(Atom "X1",Comp Sign [Comp Inv [Atom "k1"], Atom "k"]),(Atom "X2",Atom "k1")]
        --let ook = [(Atom "X1",Comp Sign [Comp Inv [Atom "k1"], Atom "k"]),(Atom "X2",Atom "k1")]
        -- let ook = [(Atom "X1",Comp Sign [Comp Inv [Atom "k1"], Atom "k"]),(Atom "X2",Atom "k")]
        --let ook = [(Atom "X1", Atom "a"), (Atom "X2", Atom "a"), (Atom "X3", Atom "a")]
        -- let ook = [(Atom "X1",Comp Sign [Comp Inv [Atom "k1"], Atom "k"]), (Atom "X2",Comp Sign [Comp Inv [Atom "k1"], Atom "k"])]
        -- let ook = [(Atom "X1", Comp Cat [Atom "A", Atom "B", Atom "C"])]
        --let ook = [(Atom "X1", Comp Apply [Atom "oooo",Comp Cat [Atom "RC",Atom "PICC",Atom "IDpicc"]])]
        -- let ook = [(Atom "X1",Comp Exp [Atom "g", Atom "X"]) ,]
        -- let ook = [(Atom "X15",Comp Scrypt [] [Atom "skag",Comp Apply [] [Atom "frmker2a",Atom "ath",Atom "C",Atom "g",Atom "KCG",Atom "T1"]]),(Atom "X16",Comp Scrypt [] [Atom "Ktemp",Comp Apply [] [Atom "frmker2b",Atom "g",Atom "KCG",Atom "T1",Atom "N1"]]),(Atom "X12",Atom "T0"),(Atom "X11",Atom "N1"),(Atom "X10",Atom "n2"),(Atom "X9",Atom "tag"),(Atom "X8",Comp Inv [] [Comp Pk [] [Atom "C"]]),(Atom "X7",Comp Pk [] [Atom "C"]),(Atom "X6",Comp Pk [] [Atom "g"]),(Atom "X5",Comp Pk [] [Atom "ath"]),(Atom "X4",Atom "s"),(Atom "X3",Atom "g"),(Atom "X2",Atom "ath"),(Atom "X1",Atom "C"),(Atom "X21",Atom "Ktemp"),(Atom "X20",Comp Sign [] [Comp Inv [] [Comp Pk [] [Atom "ath"]],Atom "Ktemp"]),(Atom "X19",Atom "tag"),(Atom "X18",Comp Apply [] [Atom "frmker2c",Atom "tag",Comp Sign [] [Comp Inv [] [Comp Pk [] [Atom "ath"]],Atom "Ktemp"]]),(Atom "X17",Comp Crypt [] [Comp Pk [] [Atom "C"],Comp Apply [] [Atom "frmker2c",Atom "tag",Comp Sign [] [Comp Inv [] [Comp Pk [] [Atom "ath"]],Atom "Ktemp"]]]),(Atom "X14",Atom "C"),(Atom "X13",Comp Apply [] [Atom "frmker2",Atom "C",Comp Scrypt [] [Atom "skag",Comp Apply [] [Atom "frmker2a",Atom "ath",Atom "C",Atom "g",Atom "KCG",Atom "T1"]],Comp Scrypt [] [Atom "Ktemp",Comp Apply [] [Atom "frmker2b",Atom "g",Atom "KCG",Atom "T1",Atom "N1"]],Comp Crypt [] [Comp Pk [] [Atom "C"],Comp Apply [] [Atom "frmker2c",Atom "tag",Comp Sign [] [Comp Inv [] [Comp Pk [] [Atom "ath"]],Atom "Ktemp"]]]])]
        -- let ook = [(Atom "X10",Comp Apply [] [Atom "frmf1",Comp Sign [] [Comp Prv [] [Atom "Kt"],Comp Pub [] [Atom "Kt"]],Comp Pub [] [Atom "Kt"],Comp Prv [] [Atom "Kt"]]),(Atom "X11",Comp Sign [] [Comp Prv [] [Atom "Kt"],Comp Pub [] [Atom "Kt"]]),(Atom "X14",Comp Pub [] [Atom "Kt"]),(Atom "X12",Comp Pub [] [Atom "Kt"]),(Atom "X13",Comp Prv [] [Atom "Kt"]),(Atom "X1",Atom "Ex"),(Atom "X2",Atom "Br"),(Atom "X3",Atom "Sr"),(Atom "X4",Atom "SP"),(Atom "X5",Comp Pk [] [Atom "Ex"]),(Atom "X6",Comp Inv [] [Comp Pk [] [Atom "Ex"]]),(Atom "X7",Comp Sign [] [Comp Inv [] [Comp Pk [] [Atom "Sr"]],Comp Apply [] [Atom "frmhok1",Atom "alphaKc",Atom "kc"]]),(Atom "X8",Atom "keygen"),(Atom "X9",Comp Pk [] [Atom "Sr"]),(Atom "X15",Comp Pub [] [Atom "Kb"])]
        -- print (fst' (analyze [] ook ook) );
        -- print ("\n\n *************************\n\n\n\n" )
        -- print (trd' (analyze [] ook ook))
        -- print "Herro!!"
        -- print (trd' (analyze [] ook ook)) 
        --let c =  combineAll (snd' (analyze [] ook ook)) (EOS "Hello")
        --print c
