{-# OPTIONS_GHC -w #-}
{-

APCC - Automated Protocol Composition Checker

Copyright Omar Saad Almousa, Technical Univerity of Denmark (DTU) 2014-2015
Copyright Paolo Modesti, School of Computing Science, Newcastle University 2015
 
Open Source Fixedpoint Model-Checker version 2012b

(C) Copyright Paolo Modesti 2012
(C) Copyright Sebastian Moedersheim 2010,2012
(C) Copyright IBM Corp. 2009

All Rights Reserved.

-}

module Parser where
import Lexer
import Ast
import Msg
import Data.List
import Control.Monad

-- signOrCrypt k@(Comp Inv x) lst = Comp Sign [k,lst] -- Working 12.6
-- signOrCrypt k lst = Comp Crypt [k,lst] -- Working 12.6
 --signOrCrypt k@(Comp Inv opt x) lst = Comp Sign [] (k:lst)
-- signOrCrypt k lst = Comp Crypt [] (k:lst)
-- atomizeOptions: Deals with the annotations on Types and Operators to ALLOW users to "negotiate" attributes
-- atomizeOpts []=[]
-- atomizeOpts (at,val):rest=(at, Atom val): atomizeOpts rest
import Control.Applicative(Applicative(..))

-- parser produced by Happy Version 1.19.4

data HappyAbsSyn t5 t30
	= HappyTerminal (Token)
	| HappyErrorToken Int
	| HappyAbsSyn4 (Protocol)
	| HappyAbsSyn5 t5
	| HappyAbsSyn6 (Types)
	| HappyAbsSyn8 (Type)
	| HappyAbsSyn9 (([Type],Type))
	| HappyAbsSyn10 (TypeOpts)
	| HappyAbsSyn12 ([Ident])
	| HappyAbsSyn13 (Mappings)
	| HappyAbsSyn15 ([Type])
	| HappyAbsSyn16 (Formats)
	| HappyAbsSyn18 (Knowledge)
	| HappyAbsSyn20 ([(Ident,[Msg])])
	| HappyAbsSyn21 ([(Msg,Msg)])
	| HappyAbsSyn22 ([Msg])
	| HappyAbsSyn23 (Msg)
	| HappyAbsSyn25 (Macros)
	| HappyAbsSyn27 (Actions)
	| HappyAbsSyn29 (Action)
	| HappyAbsSyn30 t30
	| HappyAbsSyn31 (ChannelType)
	| HappyAbsSyn33 (Channel)
	| HappyAbsSyn35 (Peer)
	| HappyAbsSyn36 (Goals)
	| HappyAbsSyn38 (Goal)
	| HappyAbsSyn39 ([Peer])
	| HappyAbsSyn40 (Abstraction)
	| HappyAbsSyn42 (Private)
	| HappyAbsSyn43 (Results)

action_0 (76) = happyShift action_3
action_0 (4) = happyGoto action_4
action_0 (5) = happyGoto action_2
action_0 _ = happyFail

action_1 (76) = happyShift action_3
action_1 (5) = happyGoto action_2
action_1 _ = happyFail

action_2 (82) = happyShift action_7
action_2 (6) = happyGoto action_6
action_2 _ = happyFail

action_3 (57) = happyShift action_5
action_3 _ = happyFail

action_4 (108) = happyAccept
action_4 _ = happyFail

action_5 (45) = happyShift action_11
action_5 _ = happyFail

action_6 (96) = happyShift action_10
action_6 (13) = happyGoto action_9
action_6 _ = happyReduce_15

action_7 (57) = happyShift action_8
action_7 _ = happyFail

action_8 (45) = happyShift action_17
action_8 (7) = happyGoto action_15
action_8 (8) = happyGoto action_16
action_8 _ = happyFail

action_9 (92) = happyShift action_14
action_9 (16) = happyGoto action_13
action_9 _ = happyReduce_21

action_10 (57) = happyShift action_12
action_10 _ = happyFail

action_11 _ = happyReduce_2

action_12 (45) = happyShift action_26
action_12 (14) = happyGoto action_25
action_12 _ = happyFail

action_13 (68) = happyShift action_24
action_13 (18) = happyGoto action_23
action_13 _ = happyFail

action_14 (57) = happyShift action_22
action_14 _ = happyFail

action_15 _ = happyReduce_3

action_16 (45) = happyShift action_21
action_16 (12) = happyGoto action_20
action_16 _ = happyFail

action_17 (74) = happyShift action_19
action_17 (10) = happyGoto action_18
action_17 _ = happyReduce_9

action_18 _ = happyReduce_6

action_19 (45) = happyShift action_36
action_19 (11) = happyGoto action_35
action_19 _ = happyFail

action_20 (80) = happyShift action_34
action_20 _ = happyFail

action_21 (58) = happyShift action_33
action_21 _ = happyReduce_13

action_22 (45) = happyShift action_32
action_22 (17) = happyGoto action_31
action_22 _ = happyFail

action_23 (94) = happyShift action_30
action_23 (25) = happyGoto action_29
action_23 _ = happyReduce_41

action_24 (57) = happyShift action_28
action_24 _ = happyFail

action_25 _ = happyReduce_16

action_26 (57) = happyShift action_27
action_26 _ = happyFail

action_27 (45) = happyShift action_17
action_27 (8) = happyGoto action_48
action_27 (15) = happyGoto action_49
action_27 _ = happyFail

action_28 (45) = happyShift action_47
action_28 (19) = happyGoto action_45
action_28 (20) = happyGoto action_46
action_28 _ = happyFail

action_29 (47) = happyShift action_44
action_29 (27) = happyGoto action_43
action_29 _ = happyFail

action_30 (57) = happyShift action_42
action_30 _ = happyFail

action_31 _ = happyReduce_22

action_32 (70) = happyShift action_41
action_32 _ = happyFail

action_33 (45) = happyShift action_21
action_33 (12) = happyGoto action_40
action_33 _ = happyFail

action_34 (45) = happyShift action_17
action_34 (7) = happyGoto action_39
action_34 (8) = happyGoto action_16
action_34 _ = happyReduce_4

action_35 (56) = happyShift action_38
action_35 _ = happyFail

action_36 (91) = happyShift action_37
action_36 _ = happyFail

action_37 (45) = happyShift action_61
action_37 _ = happyFail

action_38 _ = happyReduce_10

action_39 _ = happyReduce_5

action_40 _ = happyReduce_14

action_41 (45) = happyShift action_17
action_41 (8) = happyGoto action_48
action_41 (15) = happyGoto action_60
action_41 _ = happyFail

action_42 (45) = happyShift action_59
action_42 (26) = happyGoto action_58
action_42 _ = happyFail

action_43 (65) = happyShift action_57
action_43 (36) = happyGoto action_56
action_43 _ = happyFail

action_44 (57) = happyShift action_54
action_44 (70) = happyShift action_55
action_44 _ = happyFail

action_45 _ = happyReduce_25

action_46 (85) = happyShift action_53
action_46 _ = happyReduce_27

action_47 (57) = happyShift action_52
action_47 _ = happyFail

action_48 (58) = happyShift action_51
action_48 _ = happyReduce_19

action_49 (67) = happyShift action_50
action_49 _ = happyFail

action_50 (45) = happyShift action_17
action_50 (8) = happyGoto action_87
action_50 _ = happyFail

action_51 (45) = happyShift action_17
action_51 (8) = happyGoto action_48
action_51 (15) = happyGoto action_86
action_51 _ = happyFail

action_52 (45) = happyShift action_80
action_52 (69) = happyShift action_81
action_52 (70) = happyShift action_82
action_52 (73) = happyShift action_83
action_52 (22) = happyGoto action_84
action_52 (24) = happyGoto action_85
action_52 _ = happyFail

action_53 (45) = happyShift action_80
action_53 (69) = happyShift action_81
action_53 (70) = happyShift action_82
action_53 (73) = happyShift action_83
action_53 (21) = happyGoto action_77
action_53 (23) = happyGoto action_78
action_53 (24) = happyGoto action_79
action_53 _ = happyFail

action_54 (45) = happyShift action_73
action_54 (66) = happyShift action_74
action_54 (74) = happyShift action_75
action_54 (93) = happyShift action_76
action_54 (28) = happyGoto action_69
action_54 (29) = happyGoto action_70
action_54 (33) = happyGoto action_71
action_54 (35) = happyGoto action_72
action_54 _ = happyFail

action_55 (95) = happyShift action_68
action_55 _ = happyFail

action_56 (106) = happyShift action_67
action_56 (42) = happyGoto action_66
action_56 _ = happyReduce_88

action_57 (57) = happyShift action_65
action_57 _ = happyFail

action_58 _ = happyReduce_42

action_59 (70) = happyShift action_64
action_59 _ = happyFail

action_60 (54) = happyShift action_63
action_60 _ = happyFail

action_61 (58) = happyShift action_62
action_61 _ = happyReduce_11

action_62 (45) = happyShift action_36
action_62 (11) = happyGoto action_123
action_62 _ = happyFail

action_63 (80) = happyShift action_122
action_63 _ = happyFail

action_64 (45) = happyShift action_21
action_64 (12) = happyGoto action_121
action_64 _ = happyFail

action_65 (45) = happyShift action_120
action_65 (69) = happyShift action_81
action_65 (70) = happyShift action_82
action_65 (73) = happyShift action_83
action_65 (74) = happyShift action_75
action_65 (23) = happyGoto action_115
action_65 (24) = happyGoto action_79
action_65 (34) = happyGoto action_116
action_65 (35) = happyGoto action_117
action_65 (37) = happyGoto action_118
action_65 (38) = happyGoto action_119
action_65 _ = happyFail

action_66 (105) = happyShift action_114
action_66 (43) = happyGoto action_113
action_66 _ = happyReduce_90

action_67 (57) = happyShift action_112
action_67 _ = happyFail

action_68 (54) = happyShift action_111
action_68 _ = happyFail

action_69 _ = happyReduce_45

action_70 (45) = happyShift action_73
action_70 (66) = happyShift action_74
action_70 (74) = happyShift action_75
action_70 (93) = happyShift action_76
action_70 (100) = happyShift action_110
action_70 (28) = happyGoto action_109
action_70 (29) = happyGoto action_70
action_70 (33) = happyGoto action_71
action_70 (35) = happyGoto action_72
action_70 _ = happyReduce_47

action_71 (57) = happyShift action_108
action_71 _ = happyFail

action_72 (50) = happyShift action_101
action_72 (57) = happyShift action_102
action_72 (59) = happyShift action_103
action_72 (62) = happyShift action_104
action_72 (64) = happyShift action_105
action_72 (67) = happyShift action_106
action_72 (78) = happyShift action_107
action_72 (31) = happyGoto action_100
action_72 _ = happyFail

action_73 _ = happyReduce_71

action_74 (70) = happyShift action_99
action_74 _ = happyFail

action_75 (45) = happyShift action_98
action_75 _ = happyFail

action_76 (45) = happyShift action_97
action_76 _ = happyFail

action_77 _ = happyReduce_26

action_78 (83) = happyShift action_96
action_78 _ = happyFail

action_79 _ = happyReduce_34

action_80 (70) = happyShift action_95
action_80 (74) = happyShift action_19
action_80 (10) = happyGoto action_94
action_80 _ = happyReduce_35

action_81 (45) = happyShift action_80
action_81 (69) = happyShift action_81
action_81 (70) = happyShift action_82
action_81 (73) = happyShift action_83
action_81 (22) = happyGoto action_93
action_81 (24) = happyGoto action_85
action_81 _ = happyFail

action_82 (45) = happyShift action_80
action_82 (69) = happyShift action_81
action_82 (70) = happyShift action_82
action_82 (73) = happyShift action_83
action_82 (23) = happyGoto action_92
action_82 (24) = happyGoto action_79
action_82 _ = happyFail

action_83 (45) = happyShift action_80
action_83 (69) = happyShift action_81
action_83 (70) = happyShift action_82
action_83 (73) = happyShift action_83
action_83 (22) = happyGoto action_91
action_83 (24) = happyGoto action_85
action_83 _ = happyFail

action_84 (80) = happyShift action_90
action_84 _ = happyFail

action_85 (58) = happyShift action_89
action_85 _ = happyReduce_33

action_86 _ = happyReduce_20

action_87 (80) = happyShift action_88
action_87 _ = happyFail

action_88 (45) = happyShift action_26
action_88 (14) = happyGoto action_160
action_88 _ = happyReduce_18

action_89 (45) = happyShift action_80
action_89 (69) = happyShift action_81
action_89 (70) = happyShift action_82
action_89 (73) = happyShift action_83
action_89 (22) = happyGoto action_159
action_89 (24) = happyGoto action_85
action_89 _ = happyFail

action_90 (45) = happyShift action_47
action_90 (20) = happyGoto action_158
action_90 _ = happyReduce_29

action_91 (55) = happyShift action_157
action_91 _ = happyFail

action_92 (54) = happyShift action_156
action_92 _ = happyFail

action_93 (53) = happyShift action_155
action_93 _ = happyFail

action_94 (70) = happyShift action_154
action_94 _ = happyFail

action_95 (45) = happyShift action_80
action_95 (69) = happyShift action_81
action_95 (70) = happyShift action_82
action_95 (73) = happyShift action_83
action_95 (22) = happyGoto action_153
action_95 (24) = happyGoto action_85
action_95 _ = happyFail

action_96 (45) = happyShift action_80
action_96 (69) = happyShift action_81
action_96 (70) = happyShift action_82
action_96 (73) = happyShift action_83
action_96 (23) = happyGoto action_152
action_96 (24) = happyGoto action_79
action_96 _ = happyFail

action_97 (91) = happyShift action_151
action_97 _ = happyFail

action_98 (56) = happyShift action_149
action_98 (57) = happyShift action_150
action_98 _ = happyFail

action_99 (45) = happyShift action_148
action_99 (30) = happyGoto action_147
action_99 _ = happyFail

action_100 (45) = happyShift action_73
action_100 (74) = happyShift action_75
action_100 (35) = happyGoto action_146
action_100 _ = happyFail

action_101 _ = happyReduce_58

action_102 (45) = happyShift action_17
action_102 (8) = happyGoto action_145
action_102 _ = happyFail

action_103 _ = happyReduce_61

action_104 _ = happyReduce_59

action_105 _ = happyReduce_60

action_106 _ = happyReduce_62

action_107 _ = happyReduce_57

action_108 (45) = happyShift action_80
action_108 (69) = happyShift action_81
action_108 (70) = happyShift action_82
action_108 (73) = happyShift action_83
action_108 (23) = happyGoto action_144
action_108 (24) = happyGoto action_79
action_108 _ = happyFail

action_109 _ = happyReduce_48

action_110 (45) = happyShift action_73
action_110 (66) = happyShift action_74
action_110 (74) = happyShift action_75
action_110 (93) = happyShift action_76
action_110 (29) = happyGoto action_143
action_110 (33) = happyGoto action_71
action_110 (35) = happyGoto action_72
action_110 _ = happyFail

action_111 (57) = happyShift action_142
action_111 _ = happyFail

action_112 (45) = happyShift action_80
action_112 (69) = happyShift action_81
action_112 (70) = happyShift action_82
action_112 (73) = happyShift action_83
action_112 (22) = happyGoto action_141
action_112 (24) = happyGoto action_85
action_112 _ = happyFail

action_113 (46) = happyShift action_140
action_113 (40) = happyGoto action_139
action_113 _ = happyReduce_84

action_114 (57) = happyShift action_138
action_114 _ = happyFail

action_115 (79) = happyShift action_137
action_115 _ = happyFail

action_116 (57) = happyShift action_136
action_116 _ = happyFail

action_117 (50) = happyShift action_128
action_117 (51) = happyShift action_129
action_117 (59) = happyShift action_130
action_117 (62) = happyShift action_131
action_117 (64) = happyShift action_132
action_117 (67) = happyShift action_133
action_117 (78) = happyShift action_134
action_117 (103) = happyShift action_135
action_117 (32) = happyGoto action_127
action_117 _ = happyFail

action_118 _ = happyReduce_74

action_119 (45) = happyShift action_120
action_119 (69) = happyShift action_81
action_119 (70) = happyShift action_82
action_119 (73) = happyShift action_83
action_119 (74) = happyShift action_75
action_119 (23) = happyGoto action_115
action_119 (24) = happyGoto action_79
action_119 (34) = happyGoto action_116
action_119 (35) = happyGoto action_117
action_119 (37) = happyGoto action_126
action_119 (38) = happyGoto action_119
action_119 _ = happyReduce_75

action_120 (70) = happyShift action_95
action_120 (74) = happyShift action_19
action_120 (79) = happyReduce_35
action_120 (10) = happyGoto action_94
action_120 _ = happyReduce_71

action_121 (54) = happyShift action_125
action_121 _ = happyFail

action_122 (45) = happyShift action_32
action_122 (17) = happyGoto action_124
action_122 _ = happyReduce_24

action_123 _ = happyReduce_12

action_124 _ = happyReduce_23

action_125 (91) = happyShift action_182
action_125 _ = happyFail

action_126 _ = happyReduce_76

action_127 (45) = happyShift action_73
action_127 (74) = happyShift action_75
action_127 (35) = happyGoto action_181
action_127 _ = happyFail

action_128 _ = happyReduce_65

action_129 (45) = happyShift action_73
action_129 (74) = happyShift action_75
action_129 (35) = happyGoto action_180
action_129 _ = happyFail

action_130 _ = happyReduce_67

action_131 _ = happyReduce_66

action_132 _ = happyReduce_64

action_133 _ = happyReduce_68

action_134 _ = happyReduce_63

action_135 (51) = happyShift action_179
action_135 _ = happyFail

action_136 (45) = happyShift action_80
action_136 (69) = happyShift action_81
action_136 (70) = happyShift action_82
action_136 (73) = happyShift action_83
action_136 (23) = happyGoto action_178
action_136 (24) = happyGoto action_79
action_136 _ = happyFail

action_137 (52) = happyShift action_176
action_137 (98) = happyShift action_177
action_137 _ = happyFail

action_138 (45) = happyShift action_175
action_138 (44) = happyGoto action_174
action_138 _ = happyFail

action_139 _ = happyReduce_1

action_140 (57) = happyShift action_173
action_140 _ = happyFail

action_141 _ = happyReduce_89

action_142 (45) = happyShift action_73
action_142 (66) = happyShift action_74
action_142 (74) = happyShift action_75
action_142 (93) = happyShift action_76
action_142 (28) = happyGoto action_172
action_142 (29) = happyGoto action_70
action_142 (33) = happyGoto action_71
action_142 (35) = happyGoto action_72
action_142 _ = happyFail

action_143 (100) = happyShift action_110
action_143 _ = happyReduce_55

action_144 (75) = happyShift action_171
action_144 _ = happyReduce_51

action_145 (45) = happyShift action_21
action_145 (12) = happyGoto action_170
action_145 _ = happyFail

action_146 _ = happyReduce_69

action_147 (54) = happyShift action_169
action_147 _ = happyFail

action_148 _ = happyReduce_56

action_149 _ = happyReduce_72

action_150 (45) = happyShift action_80
action_150 (69) = happyShift action_81
action_150 (70) = happyShift action_82
action_150 (73) = happyShift action_83
action_150 (23) = happyGoto action_168
action_150 (24) = happyGoto action_79
action_150 _ = happyFail

action_151 (45) = happyShift action_80
action_151 (69) = happyShift action_81
action_151 (70) = happyShift action_82
action_151 (73) = happyShift action_83
action_151 (23) = happyGoto action_167
action_151 (24) = happyGoto action_79
action_151 _ = happyFail

action_152 (58) = happyShift action_165
action_152 (80) = happyShift action_166
action_152 _ = happyFail

action_153 (54) = happyShift action_164
action_153 _ = happyFail

action_154 (45) = happyShift action_80
action_154 (69) = happyShift action_81
action_154 (70) = happyShift action_82
action_154 (73) = happyShift action_83
action_154 (22) = happyGoto action_163
action_154 (24) = happyGoto action_85
action_154 _ = happyFail

action_155 (45) = happyShift action_80
action_155 (69) = happyShift action_81
action_155 (70) = happyShift action_82
action_155 (73) = happyShift action_83
action_155 (24) = happyGoto action_162
action_155 _ = happyFail

action_156 _ = happyReduce_40

action_157 (45) = happyShift action_80
action_157 (69) = happyShift action_81
action_157 (70) = happyShift action_82
action_157 (73) = happyShift action_83
action_157 (24) = happyGoto action_161
action_157 _ = happyFail

action_158 _ = happyReduce_28

action_159 _ = happyReduce_32

action_160 _ = happyReduce_17

action_161 _ = happyReduce_37

action_162 _ = happyReduce_36

action_163 (54) = happyShift action_196
action_163 _ = happyFail

action_164 _ = happyReduce_39

action_165 (45) = happyShift action_80
action_165 (69) = happyShift action_81
action_165 (70) = happyShift action_82
action_165 (73) = happyShift action_83
action_165 (21) = happyGoto action_195
action_165 (23) = happyGoto action_78
action_165 (24) = happyGoto action_79
action_165 _ = happyFail

action_166 _ = happyReduce_30

action_167 _ = happyReduce_54

action_168 (56) = happyShift action_194
action_168 _ = happyFail

action_169 (81) = happyShift action_193
action_169 _ = happyFail

action_170 _ = happyReduce_52

action_171 (45) = happyShift action_80
action_171 (69) = happyShift action_81
action_171 (70) = happyShift action_82
action_171 (73) = happyShift action_83
action_171 (23) = happyGoto action_192
action_171 (24) = happyGoto action_79
action_171 _ = happyFail

action_172 _ = happyReduce_46

action_173 (45) = happyShift action_191
action_173 (41) = happyGoto action_190
action_173 _ = happyFail

action_174 _ = happyReduce_91

action_175 (58) = happyShift action_189
action_175 _ = happyFail

action_176 (45) = happyShift action_73
action_176 (74) = happyShift action_75
action_176 (35) = happyGoto action_186
action_176 (39) = happyGoto action_188
action_176 _ = happyFail

action_177 (45) = happyShift action_73
action_177 (74) = happyShift action_75
action_177 (35) = happyGoto action_186
action_177 (39) = happyGoto action_187
action_177 _ = happyFail

action_178 _ = happyReduce_77

action_179 (45) = happyShift action_73
action_179 (74) = happyShift action_75
action_179 (35) = happyGoto action_185
action_179 _ = happyFail

action_180 (99) = happyShift action_184
action_180 _ = happyFail

action_181 _ = happyReduce_70

action_182 (45) = happyShift action_80
action_182 (69) = happyShift action_81
action_182 (70) = happyShift action_82
action_182 (73) = happyShift action_83
action_182 (23) = happyGoto action_183
action_182 (24) = happyGoto action_79
action_182 _ = happyFail

action_183 (80) = happyShift action_204
action_183 _ = happyFail

action_184 (45) = happyShift action_80
action_184 (69) = happyShift action_81
action_184 (70) = happyShift action_82
action_184 (73) = happyShift action_83
action_184 (23) = happyGoto action_203
action_184 (24) = happyGoto action_79
action_184 _ = happyFail

action_185 (99) = happyShift action_202
action_185 _ = happyFail

action_186 (58) = happyShift action_201
action_186 _ = happyReduce_82

action_187 _ = happyReduce_81

action_188 _ = happyReduce_80

action_189 (45) = happyShift action_200
action_189 _ = happyFail

action_190 _ = happyReduce_85

action_191 (67) = happyShift action_199
action_191 _ = happyFail

action_192 (61) = happyShift action_198
action_192 _ = happyReduce_50

action_193 (45) = happyShift action_73
action_193 (66) = happyShift action_74
action_193 (74) = happyShift action_75
action_193 (93) = happyShift action_76
action_193 (29) = happyGoto action_197
action_193 (33) = happyGoto action_71
action_193 (35) = happyGoto action_72
action_193 _ = happyFail

action_194 _ = happyReduce_73

action_195 _ = happyReduce_31

action_196 _ = happyReduce_38

action_197 (90) = happyShift action_211
action_197 (100) = happyShift action_110
action_197 _ = happyFail

action_198 (45) = happyShift action_80
action_198 (69) = happyShift action_81
action_198 (70) = happyShift action_82
action_198 (73) = happyShift action_83
action_198 (23) = happyGoto action_210
action_198 (24) = happyGoto action_79
action_198 _ = happyFail

action_199 (45) = happyShift action_80
action_199 (69) = happyShift action_81
action_199 (70) = happyShift action_82
action_199 (73) = happyShift action_83
action_199 (24) = happyGoto action_209
action_199 _ = happyFail

action_200 (57) = happyShift action_208
action_200 _ = happyFail

action_201 (45) = happyShift action_73
action_201 (74) = happyShift action_75
action_201 (35) = happyGoto action_186
action_201 (39) = happyGoto action_207
action_201 _ = happyFail

action_202 (45) = happyShift action_80
action_202 (69) = happyShift action_81
action_202 (70) = happyShift action_82
action_202 (73) = happyShift action_83
action_202 (23) = happyGoto action_206
action_202 (24) = happyGoto action_79
action_202 _ = happyFail

action_203 _ = happyReduce_78

action_204 (45) = happyShift action_59
action_204 (26) = happyGoto action_205
action_204 _ = happyReduce_44

action_205 _ = happyReduce_43

action_206 _ = happyReduce_79

action_207 _ = happyReduce_83

action_208 (45) = happyShift action_80
action_208 (69) = happyShift action_81
action_208 (70) = happyShift action_82
action_208 (73) = happyShift action_83
action_208 (24) = happyGoto action_214
action_208 _ = happyFail

action_209 (80) = happyShift action_213
action_209 _ = happyReduce_86

action_210 _ = happyReduce_49

action_211 (45) = happyShift action_73
action_211 (66) = happyShift action_74
action_211 (74) = happyShift action_75
action_211 (93) = happyShift action_76
action_211 (29) = happyGoto action_212
action_211 (33) = happyGoto action_71
action_211 (35) = happyGoto action_72
action_211 _ = happyFail

action_212 (63) = happyShift action_217
action_212 (100) = happyShift action_110
action_212 _ = happyFail

action_213 (45) = happyShift action_191
action_213 (41) = happyGoto action_216
action_213 _ = happyFail

action_214 (80) = happyShift action_215
action_214 _ = happyFail

action_215 (45) = happyShift action_175
action_215 (44) = happyGoto action_218
action_215 _ = happyReduce_92

action_216 _ = happyReduce_87

action_217 _ = happyReduce_53

action_218 _ = happyReduce_93

happyReduce_1 = happyReduce 11 4 happyReduction_1
happyReduction_1 ((HappyAbsSyn40  happy_var_11) `HappyStk`
	(HappyAbsSyn43  happy_var_10) `HappyStk`
	(HappyAbsSyn42  happy_var_9) `HappyStk`
	(HappyAbsSyn36  happy_var_8) `HappyStk`
	(HappyAbsSyn27  happy_var_7) `HappyStk`
	(HappyAbsSyn25  happy_var_6) `HappyStk`
	(HappyAbsSyn18  happy_var_5) `HappyStk`
	(HappyAbsSyn16  happy_var_4) `HappyStk`
	(HappyAbsSyn13  happy_var_3) `HappyStk`
	(HappyAbsSyn6  happy_var_2) `HappyStk`
	(HappyAbsSyn5  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn4
		 ((happy_var_1,happy_var_2,happy_var_3,happy_var_4,happy_var_5,happy_var_6,happy_var_7,happy_var_8,happy_var_9,happy_var_10,happy_var_11)
	) `HappyStk` happyRest

happyReduce_2 = happySpecReduce_3  5 happyReduction_2
happyReduction_2 (HappyTerminal (TATOM _ happy_var_3))
	_
	_
	 =  HappyAbsSyn5
		 (happy_var_3
	)
happyReduction_2 _ _ _  = notHappyAtAll 

happyReduce_3 = happySpecReduce_3  6 happyReduction_3
happyReduction_3 (HappyAbsSyn6  happy_var_3)
	_
	_
	 =  HappyAbsSyn6
		 (happy_var_3
	)
happyReduction_3 _ _ _  = notHappyAtAll 

happyReduce_4 = happySpecReduce_3  7 happyReduction_4
happyReduction_4 _
	(HappyAbsSyn12  happy_var_2)
	(HappyAbsSyn8  happy_var_1)
	 =  HappyAbsSyn6
		 ([(happy_var_1,happy_var_2)]
	)
happyReduction_4 _ _ _  = notHappyAtAll 

happyReduce_5 = happyReduce 4 7 happyReduction_5
happyReduction_5 ((HappyAbsSyn6  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn12  happy_var_2) `HappyStk`
	(HappyAbsSyn8  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn6
		 ((happy_var_1,happy_var_2):happy_var_4
	) `HappyStk` happyRest

happyReduce_6 = happySpecReduce_2  8 happyReduction_6
happyReduction_6 (HappyAbsSyn10  happy_var_2)
	(HappyTerminal (TATOM _ happy_var_1))
	 =  HappyAbsSyn8
		 (case happy_var_1 of
            "Agent" -> Agent False False happy_var_2
            "Number" -> Number happy_var_2
            "PublicKey" -> PublicKey happy_var_2
            "PrivateKey" -> PrivateKey happy_var_2
            "SymmetricKey" -> SymmetricKey happy_var_2
            "Function" -> Function happy_var_2
--            "Nonce"  -> Nonce happy_var_2
--            "ImpData" -> ImpData happy_var_2
            "Msg" -> Msg happy_var_2
            "Untyped" -> Untyped happy_var_2 --I excluded this for a period, must be working in the last version
            "SeqNumber" -> SeqNumber happy_var_2 --I excluded this for a period, must be working in the last version
            "Bool" -> Boolean happy_var_2
            _ -> error ("Unknown type "++happy_var_1)
	)
happyReduction_6 _ _  = notHappyAtAll 

happyReduce_7 = happySpecReduce_3  9 happyReduction_7
happyReduction_7 (HappyAbsSyn8  happy_var_3)
	_
	(HappyAbsSyn8  happy_var_1)
	 =  HappyAbsSyn9
		 (([happy_var_1],happy_var_3)
	)
happyReduction_7 _ _ _  = notHappyAtAll 

happyReduce_8 = happySpecReduce_3  9 happyReduction_8
happyReduction_8 (HappyAbsSyn8  happy_var_3)
	_
	(HappyAbsSyn15  happy_var_1)
	 =  HappyAbsSyn9
		 ((happy_var_1,happy_var_3)
	)
happyReduction_8 _ _ _  = notHappyAtAll 

happyReduce_9 = happySpecReduce_0  10 happyReduction_9
happyReduction_9  =  HappyAbsSyn10
		 ([]
	)

happyReduce_10 = happySpecReduce_3  10 happyReduction_10
happyReduction_10 _
	(HappyAbsSyn10  happy_var_2)
	_
	 =  HappyAbsSyn10
		 (happy_var_2
	)
happyReduction_10 _ _ _  = notHappyAtAll 

happyReduce_11 = happySpecReduce_3  11 happyReduction_11
happyReduction_11 (HappyTerminal (TATOM _ happy_var_3))
	_
	(HappyTerminal (TATOM _ happy_var_1))
	 =  HappyAbsSyn10
		 ([Option (happy_var_1,Atom happy_var_3)]
	)
happyReduction_11 _ _ _  = notHappyAtAll 

happyReduce_12 = happyReduce 5 11 happyReduction_12
happyReduction_12 ((HappyAbsSyn10  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TATOM _ happy_var_3)) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TATOM _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn10
		 ((Option (happy_var_1,Atom happy_var_3)):happy_var_5
	) `HappyStk` happyRest

happyReduce_13 = happySpecReduce_1  12 happyReduction_13
happyReduction_13 (HappyTerminal (TATOM _ happy_var_1))
	 =  HappyAbsSyn12
		 ([happy_var_1]
	)
happyReduction_13 _  = notHappyAtAll 

happyReduce_14 = happySpecReduce_3  12 happyReduction_14
happyReduction_14 (HappyAbsSyn12  happy_var_3)
	_
	(HappyTerminal (TATOM _ happy_var_1))
	 =  HappyAbsSyn12
		 (happy_var_1:happy_var_3
	)
happyReduction_14 _ _ _  = notHappyAtAll 

happyReduce_15 = happySpecReduce_0  13 happyReduction_15
happyReduction_15  =  HappyAbsSyn13
		 ([]
	)

happyReduce_16 = happySpecReduce_3  13 happyReduction_16
happyReduction_16 (HappyAbsSyn13  happy_var_3)
	_
	_
	 =  HappyAbsSyn13
		 (happy_var_3
	)
happyReduction_16 _ _ _  = notHappyAtAll 

happyReduce_17 = happyReduce 7 14 happyReduction_17
happyReduction_17 ((HappyAbsSyn13  happy_var_7) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn8  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn15  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TATOM _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn13
		 (((happy_var_1, happy_var_3,happy_var_5):happy_var_7)
	) `HappyStk` happyRest

happyReduce_18 = happyReduce 6 14 happyReduction_18
happyReduction_18 (_ `HappyStk`
	(HappyAbsSyn8  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn15  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TATOM _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn13
		 (([(happy_var_1, happy_var_3,happy_var_5)])
	) `HappyStk` happyRest

happyReduce_19 = happySpecReduce_1  15 happyReduction_19
happyReduction_19 (HappyAbsSyn8  happy_var_1)
	 =  HappyAbsSyn15
		 ([happy_var_1]
	)
happyReduction_19 _  = notHappyAtAll 

happyReduce_20 = happySpecReduce_3  15 happyReduction_20
happyReduction_20 (HappyAbsSyn15  happy_var_3)
	_
	(HappyAbsSyn8  happy_var_1)
	 =  HappyAbsSyn15
		 (happy_var_1:happy_var_3
	)
happyReduction_20 _ _ _  = notHappyAtAll 

happyReduce_21 = happySpecReduce_0  16 happyReduction_21
happyReduction_21  =  HappyAbsSyn16
		 ([]
	)

happyReduce_22 = happySpecReduce_3  16 happyReduction_22
happyReduction_22 (HappyAbsSyn16  happy_var_3)
	_
	_
	 =  HappyAbsSyn16
		 (happy_var_3
	)
happyReduction_22 _ _ _  = notHappyAtAll 

happyReduce_23 = happyReduce 6 17 happyReduction_23
happyReduction_23 ((HappyAbsSyn16  happy_var_6) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn15  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TATOM _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn16
		 (((happy_var_1, happy_var_3): happy_var_6)
	) `HappyStk` happyRest

happyReduce_24 = happyReduce 5 17 happyReduction_24
happyReduction_24 (_ `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn15  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TATOM _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn16
		 (([(happy_var_1, happy_var_3)])
	) `HappyStk` happyRest

happyReduce_25 = happySpecReduce_3  18 happyReduction_25
happyReduction_25 (HappyAbsSyn18  happy_var_3)
	_
	_
	 =  HappyAbsSyn18
		 (happy_var_3
	)
happyReduction_25 _ _ _  = notHappyAtAll 

happyReduce_26 = happySpecReduce_3  19 happyReduction_26
happyReduction_26 (HappyAbsSyn21  happy_var_3)
	_
	(HappyAbsSyn20  happy_var_1)
	 =  HappyAbsSyn18
		 ((happy_var_1,happy_var_3)
	)
happyReduction_26 _ _ _  = notHappyAtAll 

happyReduce_27 = happySpecReduce_1  19 happyReduction_27
happyReduction_27 (HappyAbsSyn20  happy_var_1)
	 =  HappyAbsSyn18
		 ((happy_var_1,[])
	)
happyReduction_27 _  = notHappyAtAll 

happyReduce_28 = happyReduce 5 20 happyReduction_28
happyReduction_28 ((HappyAbsSyn20  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn22  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TATOM _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn20
		 (((happy_var_1,happy_var_3):happy_var_5)
	) `HappyStk` happyRest

happyReduce_29 = happyReduce 4 20 happyReduction_29
happyReduction_29 (_ `HappyStk`
	(HappyAbsSyn22  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TATOM _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn20
		 ([(happy_var_1,happy_var_3)]
	) `HappyStk` happyRest

happyReduce_30 = happyReduce 4 21 happyReduction_30
happyReduction_30 (_ `HappyStk`
	(HappyAbsSyn23  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn23  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn21
		 ([(happy_var_1,happy_var_3)]
	) `HappyStk` happyRest

happyReduce_31 = happyReduce 5 21 happyReduction_31
happyReduction_31 ((HappyAbsSyn21  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn23  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn23  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn21
		 (((happy_var_1,happy_var_3):happy_var_5)
	) `HappyStk` happyRest

happyReduce_32 = happySpecReduce_3  22 happyReduction_32
happyReduction_32 (HappyAbsSyn22  happy_var_3)
	_
	(HappyAbsSyn23  happy_var_1)
	 =  HappyAbsSyn22
		 (happy_var_1:happy_var_3
	)
happyReduction_32 _ _ _  = notHappyAtAll 

happyReduce_33 = happySpecReduce_1  22 happyReduction_33
happyReduction_33 (HappyAbsSyn23  happy_var_1)
	 =  HappyAbsSyn22
		 ([happy_var_1]
	)
happyReduction_33 _  = notHappyAtAll 

happyReduce_34 = happySpecReduce_1  23 happyReduction_34
happyReduction_34 (HappyAbsSyn23  happy_var_1)
	 =  HappyAbsSyn23
		 (happy_var_1
	)
happyReduction_34 _  = notHappyAtAll 

happyReduce_35 = happySpecReduce_1  24 happyReduction_35
happyReduction_35 (HappyTerminal (TATOM _ happy_var_1))
	 =  HappyAbsSyn23
		 (Atom happy_var_1
	)
happyReduction_35 _  = notHappyAtAll 

happyReduce_36 = happyReduce 4 24 happyReduction_36
happyReduction_36 ((HappyAbsSyn23  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn22  happy_var_2) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn23
		 (signOrCrypt happy_var_4 happy_var_2
	) `HappyStk` happyRest

happyReduce_37 = happyReduce 4 24 happyReduction_37
happyReduction_37 ((HappyAbsSyn23  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn22  happy_var_2) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn23
		 (Comp Scrypt [] (happy_var_4:happy_var_2)
	) `HappyStk` happyRest

happyReduce_38 = happyReduce 5 24 happyReduction_38
happyReduction_38 (_ `HappyStk`
	(HappyAbsSyn22  happy_var_4) `HappyStk`
	(HappyTerminal happy_var_3) `HappyStk`
	(HappyAbsSyn10  happy_var_2) `HappyStk`
	(HappyTerminal (TATOM _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn23
		 (-- CASE WITH TYPE OPTIONS
                                            if      happy_var_1=="inv"     then     (if ((length happy_var_4)== 1) then Comp Inv [] happy_var_4 else error("inv takes one argument") ) 
                                            else if happy_var_1=="xor"     then     (if ((length happy_var_4)== 2) then Comp Xor [] happy_var_4 else error("xor takes two arguments"))
                                            else if happy_var_1=="exp"     then     (if ((length happy_var_4)== 2) then Comp Exp [] happy_var_4 else error("exp takes two arguments") )
                                            else if happy_var_1=="hash"     then     Comp Hash happy_var_2 happy_var_4
                                            --(if ((length happy_var_4)== 1) then  Comp Hash happy_var_4 else error("Hash takes one argument"))
                                            else if happy_var_1=="mac"     then     Comp Mac happy_var_2 happy_var_4
                                            --(if ((length happy_var_4)== 2) then Comp Mac happy_var_4 )
                                            else if happy_var_1=="mult"     then     (if ((length happy_var_4)== 2) then Comp Mult [] happy_var_4 else error("mult takes two arguments"))
                                            else if happy_var_1=="pk"     then     (if ((length happy_var_4)== 1) then Comp Pk [] happy_var_4 else error("pk takes one argument"))
                                            else if happy_var_1=="sk"     then     (if ((length happy_var_4)== 1) then Comp Sk [] happy_var_4 else error("sk takes one argument"))
                                            -- else if happy_var_1=="scrypt" then (if ((length happy_var_3)== 2) then Comp Scrypt happy_var_3 else error("exp takes two arguments"))
                                            else if happy_var_1=="scrypt" then (if ((length happy_var_4)== 2) then Comp Scrypt happy_var_2 happy_var_4 else error("scrypt takes two arguments, use formats!"))
                                            else if happy_var_1=="crypt" then (if ((length happy_var_4)== 2) then Comp Crypt happy_var_2 happy_var_4 else error("crypt takes two arguments, use formats"))
                                            else if happy_var_1=="shk"     then (if ((length happy_var_4)== 2) then Comp Shk [] happy_var_4 else error("exp takes two arguments"))
                                            else if happy_var_1=="sign"     then (if ((length happy_var_4)== 2) then Comp Sign happy_var_2 happy_var_4 else error("Sign takes two arguments"))
                                            else if happy_var_1=="signh" then (if ((length happy_var_4)== 2) then Comp SignH happy_var_2 happy_var_4 else error("Signh takes two arguments"))
                                            else if happy_var_1=="fsignh" then (if ((length happy_var_4)== 2) then Comp FsignH happy_var_2 happy_var_4 else error("Fsignh takes two arguments"))
                                                                                        else if happy_var_1=="pvk"     then     (if ((length happy_var_4)== 1) then Comp PvK [] happy_var_4 else error("pvk takes one argument"))
                                                                                        else if happy_var_1=="pbk"     then     (if ((length happy_var_4)== 1) then Comp PbK [] happy_var_4 else error("pbk takes one argument"))
                                                                                        else if happy_var_1=="pub"     then     (if ((length happy_var_4)== 1) then Comp Pub [] happy_var_4 else error("pub takes one argument"))
                                            -- else if (not (( elem happy_var_1 (map fst f)) || ( elem happy_var_1  (map fst m)) )) then error ("APS Parse error: " ++ f ++ " undeclared identifier\n" )
                                            -- || ( elem happy_var_1 (map fst c))
                                            else case happy_var_4 of
                                             [x] -> Comp Apply [] ((Atom happy_var_1):[x])
                                             _ -> Comp Apply [] ((Atom happy_var_1):happy_var_4)
	) `HappyStk` happyRest

happyReduce_39 = happyReduce 4 24 happyReduction_39
happyReduction_39 (_ `HappyStk`
	(HappyAbsSyn22  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TATOM _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn23
		 (-- CASE NO TYPE OPTIONS
                                            if         happy_var_1=="inv"     then     (if ((length happy_var_3)== 1) then Comp Inv [] happy_var_3 else error("inv takes one argument") ) 
                                            else if happy_var_1=="xor"     then     (if ((length happy_var_3)== 2) then Comp Xor [] happy_var_3 else error("xor takes two arguments"))
                                            else if happy_var_1=="exp"     then     (if ((length happy_var_3)== 2) then Comp Exp [] happy_var_3 else error("exp takes two arguments") )
                                            else if happy_var_1=="hash"     then     Comp Hash [] happy_var_3
                                            --(if ((length happy_var_3)== 1) then  Comp Hash happy_var_3 else error("Hash takes  one argument"))
                                            else if happy_var_1=="mac"     then     Comp Mac [] happy_var_3
                                            --(if ((length happy_var_3)== 2) then Comp Mac happy_var_3 )
                                            else if happy_var_1=="mult"     then     (if ((length happy_var_3)== 2) then Comp Mult [] happy_var_3 else error("mult takes two arguments"))
                                            else if happy_var_1=="pk"     then     (if ((length happy_var_3)== 1) then Comp Pk [] happy_var_3 else error("pk takes one argument"))
                                            else if happy_var_1=="sk"     then     (if ((length happy_var_3)== 1) then Comp Sk [] happy_var_3 else error("sk takes one argument"))
                                            -- else if happy_var_1=="scrypt" then (if ((length happy_var_3)== 2) then Comp Scrypt happy_var_3 else error("exp takes two arguments"))
                                            else if happy_var_1=="scrypt" then (if ((length happy_var_3)== 2) then Comp Scrypt [] happy_var_3 else error("scrypt takes two arguments, use formats!"))
                                            else if happy_var_1=="crypt" then (if ((length happy_var_3)== 2) then Comp Crypt [] happy_var_3 else error("crypt takes two arguments, use formats"))
                                            else if happy_var_1=="shk"     then (if ((length happy_var_3)== 2) then Comp Shk [] happy_var_3 else error("exp takes two arguments"))
                                            else if happy_var_1=="sign"     then (if ((length happy_var_3)== 2) then Comp Sign [] happy_var_3 else error("Sign takes two arguments"))
                                            else if happy_var_1=="signh" then (if ((length happy_var_3)== 2) then Comp SignH [] happy_var_3 else error("Signh takes two arguments"))
                                            else if happy_var_1=="fsignh" then (if ((length happy_var_3)== 2) then Comp FsignH [] happy_var_3 else error("fsignh takes two arguments"))
                                                                                        else if happy_var_1=="pvk"     then     (if ((length happy_var_3)== 1) then Comp PvK[] happy_var_3 else error("pvk takes one argument"))
                                                                                        else if happy_var_1=="pbk"     then     (if ((length happy_var_3)== 1) then Comp PbK [] happy_var_3 else error("pbk takes one argument"))
                                                                                        else if happy_var_1=="pub"     then     (if ((length happy_var_3)== 1) then Comp Pub [] happy_var_3 else error("pub takes one argument"))
                                            -- else if (not (( elem happy_var_1 (map fst f)) || ( elem happy_var_1  (map fst m)) )) then error ("APS Parse error: " ++ f ++ " undeclared identifier\n" )
                                            -- || ( elem happy_var_1 (map fst c))
                                            else case happy_var_3 of
                                             [x] -> Comp Apply [] ((Atom happy_var_1):[x])
                                             _ -> Comp Apply [] ((Atom happy_var_1):happy_var_3)
	) `HappyStk` happyRest

happyReduce_40 = happySpecReduce_3  24 happyReduction_40
happyReduction_40 _
	(HappyAbsSyn23  happy_var_2)
	_
	 =  HappyAbsSyn23
		 (happy_var_2
	)
happyReduction_40 _ _ _  = notHappyAtAll 

happyReduce_41 = happySpecReduce_0  25 happyReduction_41
happyReduction_41  =  HappyAbsSyn25
		 ([]
	)

happyReduce_42 = happySpecReduce_3  25 happyReduction_42
happyReduction_42 (HappyAbsSyn25  happy_var_3)
	_
	_
	 =  HappyAbsSyn25
		 (happy_var_3
	)
happyReduction_42 _ _ _  = notHappyAtAll 

happyReduce_43 = happyReduce 8 26 happyReduction_43
happyReduction_43 ((HappyAbsSyn25  happy_var_8) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn23  happy_var_6) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn12  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TATOM _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn25
		 (((happy_var_1,happy_var_3,happy_var_6) : happy_var_8)
	) `HappyStk` happyRest

happyReduce_44 = happyReduce 7 26 happyReduction_44
happyReduction_44 (_ `HappyStk`
	(HappyAbsSyn23  happy_var_6) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn12  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TATOM _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn25
		 (([(happy_var_1,happy_var_3,happy_var_6)])
	) `HappyStk` happyRest

happyReduce_45 = happySpecReduce_3  27 happyReduction_45
happyReduction_45 (HappyAbsSyn27  happy_var_3)
	_
	_
	 =  HappyAbsSyn27
		 (happy_var_3
	)
happyReduction_45 _ _ _  = notHappyAtAll 

happyReduce_46 = happyReduce 6 27 happyReduction_46
happyReduction_46 ((HappyAbsSyn27  happy_var_6) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn27
		 (happy_var_6
	) `HappyStk` happyRest

happyReduce_47 = happySpecReduce_1  28 happyReduction_47
happyReduction_47 (HappyAbsSyn29  happy_var_1)
	 =  HappyAbsSyn27
		 ([happy_var_1]
	)
happyReduction_47 _  = notHappyAtAll 

happyReduce_48 = happySpecReduce_2  28 happyReduction_48
happyReduction_48 (HappyAbsSyn27  happy_var_2)
	(HappyAbsSyn29  happy_var_1)
	 =  HappyAbsSyn27
		 ((happy_var_1:happy_var_2)
	)
happyReduction_48 _ _  = notHappyAtAll 

happyReduce_49 = happyReduce 7 29 happyReduction_49
happyReduction_49 ((HappyAbsSyn23  happy_var_7) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn23  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn23  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn33  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn29
		 (Exchange (happy_var_1,happy_var_3,Just happy_var_5,Just happy_var_7)
	) `HappyStk` happyRest

happyReduce_50 = happyReduce 5 29 happyReduction_50
happyReduction_50 ((HappyAbsSyn23  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn23  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn33  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn29
		 (Exchange (happy_var_1,happy_var_3,Just happy_var_5,Nothing)
	) `HappyStk` happyRest

happyReduce_51 = happySpecReduce_3  29 happyReduction_51
happyReduction_51 (HappyAbsSyn23  happy_var_3)
	_
	(HappyAbsSyn33  happy_var_1)
	 =  HappyAbsSyn29
		 (Exchange (happy_var_1,happy_var_3,Nothing,Nothing)
	)
happyReduction_51 _ _ _  = notHappyAtAll 

happyReduce_52 = happyReduce 4 29 happyReduction_52
happyReduction_52 ((HappyAbsSyn12  happy_var_4) `HappyStk`
	(HappyAbsSyn8  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn35  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn29
		 (CreateFresh ((happy_var_1,DecFresh,happy_var_1),(happy_var_3,happy_var_4))
	) `HappyStk` happyRest

happyReduce_53 = happyReduce 9 29 happyReduction_53
happyReduction_53 (_ `HappyStk`
	(HappyAbsSyn29  happy_var_8) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn29  happy_var_6) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn30  happy_var_3) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn29
		 (If (happy_var_3, happy_var_6 ,happy_var_8)
	) `HappyStk` happyRest

happyReduce_54 = happyReduce 4 29 happyReduction_54
happyReduction_54 ((HappyAbsSyn23  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TATOM _ happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn29
		 (Let (happy_var_2, happy_var_4)
	) `HappyStk` happyRest

happyReduce_55 = happySpecReduce_3  29 happyReduction_55
happyReduction_55 (HappyAbsSyn29  happy_var_3)
	_
	(HappyAbsSyn29  happy_var_1)
	 =  HappyAbsSyn29
		 (Or (happy_var_1,happy_var_3)
	)
happyReduction_55 _ _ _  = notHappyAtAll 

happyReduce_56 = happySpecReduce_1  30 happyReduction_56
happyReduction_56 (HappyTerminal (TATOM _ happy_var_1))
	 =  HappyAbsSyn30
		 (happy_var_1
	)
happyReduction_56 _  = notHappyAtAll 

happyReduce_57 = happySpecReduce_1  31 happyReduction_57
happyReduction_57 _
	 =  HappyAbsSyn31
		 (Secure
	)

happyReduce_58 = happySpecReduce_1  31 happyReduction_58
happyReduction_58 _
	 =  HappyAbsSyn31
		 (Authentic
	)

happyReduce_59 = happySpecReduce_1  31 happyReduction_59
happyReduction_59 _
	 =  HappyAbsSyn31
		 (FreshAuthentic
	)

happyReduce_60 = happySpecReduce_1  31 happyReduction_60
happyReduction_60 _
	 =  HappyAbsSyn31
		 (FreshSecure
	)

happyReduce_61 = happySpecReduce_1  31 happyReduction_61
happyReduction_61 _
	 =  HappyAbsSyn31
		 (Confidential
	)

happyReduce_62 = happySpecReduce_1  31 happyReduction_62
happyReduction_62 _
	 =  HappyAbsSyn31
		 (Insecure
	)

happyReduce_63 = happySpecReduce_1  32 happyReduction_63
happyReduction_63 _
	 =  HappyAbsSyn31
		 (Secure
	)

happyReduce_64 = happySpecReduce_1  32 happyReduction_64
happyReduction_64 _
	 =  HappyAbsSyn31
		 (FreshSecure
	)

happyReduce_65 = happySpecReduce_1  32 happyReduction_65
happyReduction_65 _
	 =  HappyAbsSyn31
		 (Authentic
	)

happyReduce_66 = happySpecReduce_1  32 happyReduction_66
happyReduction_66 _
	 =  HappyAbsSyn31
		 (FreshAuthentic
	)

happyReduce_67 = happySpecReduce_1  32 happyReduction_67
happyReduction_67 _
	 =  HappyAbsSyn31
		 (Confidential
	)

happyReduce_68 = happySpecReduce_1  32 happyReduction_68
happyReduction_68 _
	 =  HappyAbsSyn31
		 (Insecure
	)

happyReduce_69 = happySpecReduce_3  33 happyReduction_69
happyReduction_69 (HappyAbsSyn35  happy_var_3)
	(HappyAbsSyn31  happy_var_2)
	(HappyAbsSyn35  happy_var_1)
	 =  HappyAbsSyn33
		 ((happy_var_1,happy_var_2,happy_var_3)
	)
happyReduction_69 _ _ _  = notHappyAtAll 

happyReduce_70 = happySpecReduce_3  34 happyReduction_70
happyReduction_70 (HappyAbsSyn35  happy_var_3)
	(HappyAbsSyn31  happy_var_2)
	(HappyAbsSyn35  happy_var_1)
	 =  HappyAbsSyn33
		 ((happy_var_1, happy_var_2,happy_var_3)
	)
happyReduction_70 _ _ _  = notHappyAtAll 

happyReduce_71 = happySpecReduce_1  35 happyReduction_71
happyReduction_71 (HappyTerminal (TATOM _ happy_var_1))
	 =  HappyAbsSyn35
		 ((happy_var_1, Atom happy_var_1,False,Nothing)
	)
happyReduction_71 _  = notHappyAtAll 

happyReduce_72 = happySpecReduce_3  35 happyReduction_72
happyReduction_72 _
	(HappyTerminal (TATOM _ happy_var_2))
	_
	 =  HappyAbsSyn35
		 ((happy_var_2, Atom happy_var_2, True,Nothing)
	)
happyReduction_72 _ _ _  = notHappyAtAll 

happyReduce_73 = happyReduce 5 35 happyReduction_73
happyReduction_73 (_ `HappyStk`
	(HappyAbsSyn23  happy_var_4) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TATOM _ happy_var_2)) `HappyStk`
	_ `HappyStk`
	happyRest)
	 = HappyAbsSyn35
		 ((happy_var_2, Atom happy_var_2, True, Just happy_var_4)
	) `HappyStk` happyRest

happyReduce_74 = happySpecReduce_3  36 happyReduction_74
happyReduction_74 (HappyAbsSyn36  happy_var_3)
	_
	_
	 =  HappyAbsSyn36
		 (happy_var_3
	)
happyReduction_74 _ _ _  = notHappyAtAll 

happyReduce_75 = happySpecReduce_1  37 happyReduction_75
happyReduction_75 (HappyAbsSyn38  happy_var_1)
	 =  HappyAbsSyn36
		 ([happy_var_1]
	)
happyReduction_75 _  = notHappyAtAll 

happyReduce_76 = happySpecReduce_2  37 happyReduction_76
happyReduction_76 (HappyAbsSyn36  happy_var_2)
	(HappyAbsSyn38  happy_var_1)
	 =  HappyAbsSyn36
		 (happy_var_1:happy_var_2
	)
happyReduction_76 _ _  = notHappyAtAll 

happyReduce_77 = happySpecReduce_3  38 happyReduction_77
happyReduction_77 (HappyAbsSyn23  happy_var_3)
	_
	(HappyAbsSyn33  happy_var_1)
	 =  HappyAbsSyn38
		 ((ChGoal happy_var_1 happy_var_3)
	)
happyReduction_77 _ _ _  = notHappyAtAll 

happyReduce_78 = happyReduce 5 38 happyReduction_78
happyReduction_78 ((HappyAbsSyn23  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn35  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn35  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn38
		 ((ChGoal (happy_var_3,FreshAuthentic,happy_var_1) happy_var_5)
	) `HappyStk` happyRest

happyReduce_79 = happyReduce 6 38 happyReduction_79
happyReduction_79 ((HappyAbsSyn23  happy_var_6) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn35  happy_var_4) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn35  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn38
		 ((ChGoal (happy_var_4,Authentic,happy_var_1) happy_var_6)
	) `HappyStk` happyRest

happyReduce_80 = happyReduce 4 38 happyReduction_80
happyReduction_80 ((HappyAbsSyn39  happy_var_4) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn23  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn38
		 ((Secret happy_var_1 happy_var_4)
	) `HappyStk` happyRest

happyReduce_81 = happyReduce 4 38 happyReduction_81
happyReduction_81 ((HappyAbsSyn39  happy_var_4) `HappyStk`
	_ `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn23  happy_var_1) `HappyStk`
	happyRest)
	 = HappyAbsSyn38
		 ((Secret happy_var_1 happy_var_4)
	) `HappyStk` happyRest

happyReduce_82 = happySpecReduce_1  39 happyReduction_82
happyReduction_82 (HappyAbsSyn35  happy_var_1)
	 =  HappyAbsSyn39
		 ([happy_var_1]
	)
happyReduction_82 _  = notHappyAtAll 

happyReduce_83 = happySpecReduce_3  39 happyReduction_83
happyReduction_83 (HappyAbsSyn39  happy_var_3)
	_
	(HappyAbsSyn35  happy_var_1)
	 =  HappyAbsSyn39
		 ((happy_var_1:happy_var_3)
	)
happyReduction_83 _ _ _  = notHappyAtAll 

happyReduce_84 = happySpecReduce_0  40 happyReduction_84
happyReduction_84  =  HappyAbsSyn40
		 ([]
	)

happyReduce_85 = happySpecReduce_3  40 happyReduction_85
happyReduction_85 (HappyAbsSyn40  happy_var_3)
	_
	_
	 =  HappyAbsSyn40
		 (happy_var_3
	)
happyReduction_85 _ _ _  = notHappyAtAll 

happyReduce_86 = happySpecReduce_3  41 happyReduction_86
happyReduction_86 (HappyAbsSyn23  happy_var_3)
	_
	(HappyTerminal (TATOM _ happy_var_1))
	 =  HappyAbsSyn40
		 ([(happy_var_1,happy_var_3)]
	)
happyReduction_86 _ _ _  = notHappyAtAll 

happyReduce_87 = happyReduce 5 41 happyReduction_87
happyReduction_87 ((HappyAbsSyn40  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn23  happy_var_3) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TATOM _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn40
		 (((happy_var_1,happy_var_3):happy_var_5)
	) `HappyStk` happyRest

happyReduce_88 = happySpecReduce_0  42 happyReduction_88
happyReduction_88  =  HappyAbsSyn42
		 ([]
	)

happyReduce_89 = happySpecReduce_3  42 happyReduction_89
happyReduction_89 (HappyAbsSyn22  happy_var_3)
	_
	_
	 =  HappyAbsSyn42
		 (happy_var_3
	)
happyReduction_89 _ _ _  = notHappyAtAll 

happyReduce_90 = happySpecReduce_0  43 happyReduction_90
happyReduction_90  =  HappyAbsSyn43
		 ([]
	)

happyReduce_91 = happySpecReduce_3  43 happyReduction_91
happyReduction_91 (HappyAbsSyn43  happy_var_3)
	_
	_
	 =  HappyAbsSyn43
		 (happy_var_3
	)
happyReduction_91 _ _ _  = notHappyAtAll 

happyReduce_92 = happyReduce 6 44 happyReduction_92
happyReduction_92 (_ `HappyStk`
	(HappyAbsSyn23  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TATOM _ happy_var_3)) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TATOM _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn43
		 ([(happy_var_1,happy_var_3,happy_var_5)]
	) `HappyStk` happyRest

happyReduce_93 = happyReduce 7 44 happyReduction_93
happyReduction_93 ((HappyAbsSyn43  happy_var_7) `HappyStk`
	_ `HappyStk`
	(HappyAbsSyn23  happy_var_5) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TATOM _ happy_var_3)) `HappyStk`
	_ `HappyStk`
	(HappyTerminal (TATOM _ happy_var_1)) `HappyStk`
	happyRest)
	 = HappyAbsSyn43
		 ((happy_var_1,happy_var_3,happy_var_5):happy_var_7
	) `HappyStk` happyRest

happyNewToken action sts stk [] =
	action 108 108 notHappyAtAll (HappyState action) sts stk []

happyNewToken action sts stk (tk:tks) =
	let cont i = action i i tk (HappyState action) sts stk tks in
	case tk of {
	TATOM _ happy_dollar_dollar -> cont 45;
	TABSTRACTION _ -> cont 46;
	TACTIONS _ -> cont 47;
	TAGENTS _ -> cont 48;
	TAS _ -> cont 49;
	TAUTHCH _ -> cont 50;
	TAUTHENTICATES _ -> cont 51;
	TBETWEEN _ -> cont 52;
	TCLOSEB _ -> cont 53;
	TCLOSEP _ -> cont 54;
	TCLOSESCRYPT _ -> cont 55;
	TCLOSESQB _ -> cont 56;
	TCOLON _ -> cont 57;
	TCOMMA _ -> cont 58;
	TCONFCH _ -> cont 59;
	TDOT _ -> cont 60;
	TEXCLAM  _ -> cont 61;
	TFAUTHCH _ -> cont 62;
	TFI _ -> cont 63;
	TFSECCH _ -> cont 64;
	TGOALS _ -> cont 65;
	TIF _ -> cont 66;
	TINSECCH _ -> cont 67;
	TKNOWLEDGE _ -> cont 68;
	TOPENB _ -> cont 69;
	TOPENP _ -> cont 70;
	TBEGINCOMMENT _ -> cont 71;
	TENDCOMMENT _ -> cont 72;
	TOPENSCRYPT _ -> cont 73;
	TOPENSQB _ -> cont 74;
	TPERCENT _ -> cont 75;
	TPROTOCOL _ -> cont 76;
	TQUESTION _ -> cont 77;
	TSECCH _ -> cont 78;
	TSECRET _ -> cont 79;
	TSEMICOLON _ -> cont 80;
	TTHEN _ -> cont 81;
	TTYPES _ -> cont 82;
	TUNEQUAL _ -> cont 83;
	TVERT _ -> cont 84;
	TWHERE _ -> cont 85;
	TEXIT _ -> cont 86;
	TNONCES _ -> cont 87;
	TRETURN _ -> cont 88;
	TDATABSE _ -> cont 89;
	TELSE _ -> cont 90;
	TEQUAL _ -> cont 91;
	TFORMATS _ -> cont 92;
	TLET _ -> cont 93;
	TMACROS _ -> cont 94;
	TMAIN p -> cont 95;
	TMAPPINGS _ -> cont 96;
	TMINUS _ -> cont 97;
	TOF _ -> cont 98;
	TON _ -> cont 99;
	TOR _ -> cont 100;
	TOTHER _ -> cont 101;
	TPLUS _ -> cont 102;
	TWEAKLY _ -> cont 103;
	TAT _ -> cont 104;
	TRESULTS _ -> cont 105;
	TPRIVATE _ -> cont 106;
	TFUNSIGN _ -> cont 107;
	_ -> happyError' (tk:tks)
	}

happyError_ 108 tk tks = happyError' tks
happyError_ _ tk tks = happyError' (tk:tks)

newtype HappyIdentity a = HappyIdentity a
happyIdentity = HappyIdentity
happyRunIdentity (HappyIdentity a) = a

instance Functor HappyIdentity where
    fmap f (HappyIdentity a) = HappyIdentity (f a)

instance Applicative HappyIdentity where
    pure    = return
    a <*> b = (fmap id a) <*> b
instance Monad HappyIdentity where
    return = HappyIdentity
    (HappyIdentity p) >>= q = q p

happyThen :: () => HappyIdentity a -> (a -> HappyIdentity b) -> HappyIdentity b
happyThen = (>>=)
happyReturn :: () => a -> HappyIdentity a
happyReturn = (return)
happyThen1 m k tks = (>>=) m (\a -> k a tks)
happyReturn1 :: () => a -> b -> HappyIdentity a
happyReturn1 = \a tks -> (return) a
happyError' :: () => [(Token)] -> HappyIdentity a
happyError' = HappyIdentity . happyError

apspareser tks = happyRunIdentity happySomeParser where
  happySomeParser = happyThen (happyParse action_0 tks) (\x -> case x of {HappyAbsSyn4 z -> happyReturn z; _other -> notHappyAtAll })

happySeq = happyDontSeq


happyError :: [Token] -> a
happyError tks = error ("APS Parse error at " ++ lcn ++ "\n" )
    where
    lcn =     case tks of
          [] -> "end of file"
          tk:_ -> "line " ++ show l ++ ", column " ++ show c ++ " - Token: " ++ show tk
            where
            AlexPn _ l c = token_posn tk
{-# LINE 1 "templates\GenericTemplate.hs" #-}
{-# LINE 1 "templates\\GenericTemplate.hs" #-}
{-# LINE 1 "<built-in>" #-}
{-# LINE 1 "<command-line>" #-}
{-# LINE 1 "templates\\GenericTemplate.hs" #-}
-- Id: GenericTemplate.hs,v 1.26 2005/01/14 14:47:22 simonmar Exp 

{-# LINE 13 "templates\\GenericTemplate.hs" #-}

{-# LINE 46 "templates\\GenericTemplate.hs" #-}








{-# LINE 67 "templates\\GenericTemplate.hs" #-}

{-# LINE 77 "templates\\GenericTemplate.hs" #-}

{-# LINE 86 "templates\\GenericTemplate.hs" #-}

infixr 9 `HappyStk`
data HappyStk a = HappyStk a (HappyStk a)

-----------------------------------------------------------------------------
-- starting the parse

happyParse start_state = happyNewToken start_state notHappyAtAll notHappyAtAll

-----------------------------------------------------------------------------
-- Accepting the parse

-- If the current token is (1), it means we've just accepted a partial
-- parse (a %partial parser).  We must ignore the saved token on the top of
-- the stack in this case.
happyAccept (1) tk st sts (_ `HappyStk` ans `HappyStk` _) =
        happyReturn1 ans
happyAccept j tk st sts (HappyStk ans _) = 
         (happyReturn1 ans)

-----------------------------------------------------------------------------
-- Arrays only: do the next action

{-# LINE 155 "templates\\GenericTemplate.hs" #-}

-----------------------------------------------------------------------------
-- HappyState data type (not arrays)



newtype HappyState b c = HappyState
        (Int ->                    -- token number
         Int ->                    -- token number (yes, again)
         b ->                           -- token semantic value
         HappyState b c ->              -- current state
         [HappyState b c] ->            -- state stack
         c)



-----------------------------------------------------------------------------
-- Shifting a token

happyShift new_state (1) tk st sts stk@(x `HappyStk` _) =
     let i = (case x of { HappyErrorToken (i) -> i }) in
--     trace "shifting the error token" $
     new_state i i tk (HappyState (new_state)) ((st):(sts)) (stk)

happyShift new_state i tk st sts stk =
     happyNewToken new_state ((st):(sts)) ((HappyTerminal (tk))`HappyStk`stk)

-- happyReduce is specialised for the common cases.

happySpecReduce_0 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_0 nt fn j tk st@((HappyState (action))) sts stk
     = action nt j tk st ((st):(sts)) (fn `HappyStk` stk)

happySpecReduce_1 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_1 nt fn j tk _ sts@(((st@(HappyState (action))):(_))) (v1`HappyStk`stk')
     = let r = fn v1 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_2 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_2 nt fn j tk _ ((_):(sts@(((st@(HappyState (action))):(_))))) (v1`HappyStk`v2`HappyStk`stk')
     = let r = fn v1 v2 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_3 i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happySpecReduce_3 nt fn j tk _ ((_):(((_):(sts@(((st@(HappyState (action))):(_))))))) (v1`HappyStk`v2`HappyStk`v3`HappyStk`stk')
     = let r = fn v1 v2 v3 in
       happySeq r (action nt j tk st sts (r `HappyStk` stk'))

happyReduce k i fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyReduce k nt fn j tk st sts stk
     = case happyDrop (k - ((1) :: Int)) sts of
         sts1@(((st1@(HappyState (action))):(_))) ->
                let r = fn stk in  -- it doesn't hurt to always seq here...
                happyDoSeq r (action nt j tk st1 sts1 r)

happyMonadReduce k nt fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyMonadReduce k nt fn j tk st sts stk =
      case happyDrop k ((st):(sts)) of
        sts1@(((st1@(HappyState (action))):(_))) ->
          let drop_stk = happyDropStk k stk in
          happyThen1 (fn stk tk) (\r -> action nt j tk st1 sts1 (r `HappyStk` drop_stk))

happyMonad2Reduce k nt fn (1) tk st sts stk
     = happyFail (1) tk st sts stk
happyMonad2Reduce k nt fn j tk st sts stk =
      case happyDrop k ((st):(sts)) of
        sts1@(((st1@(HappyState (action))):(_))) ->
         let drop_stk = happyDropStk k stk





             new_state = action

          in
          happyThen1 (fn stk tk) (\r -> happyNewToken new_state sts1 (r `HappyStk` drop_stk))

happyDrop (0) l = l
happyDrop n ((_):(t)) = happyDrop (n - ((1) :: Int)) t

happyDropStk (0) l = l
happyDropStk n (x `HappyStk` xs) = happyDropStk (n - ((1)::Int)) xs

-----------------------------------------------------------------------------
-- Moving to a new state after a reduction

{-# LINE 256 "templates\\GenericTemplate.hs" #-}
happyGoto action j tk st = action j j tk (HappyState action)


-----------------------------------------------------------------------------
-- Error recovery ((1) is the error token)

-- parse error if we are in recovery and we fail again
happyFail (1) tk old_st _ stk@(x `HappyStk` _) =
     let i = (case x of { HappyErrorToken (i) -> i }) in
--      trace "failing" $ 
        happyError_ i tk

{-  We don't need state discarding for our restricted implementation of
    "error".  In fact, it can cause some bogus parses, so I've disabled it
    for now --SDM

-- discard a state
happyFail  (1) tk old_st (((HappyState (action))):(sts)) 
                                                (saved_tok `HappyStk` _ `HappyStk` stk) =
--      trace ("discarding state, depth " ++ show (length stk))  $
        action (1) (1) tk (HappyState (action)) sts ((saved_tok`HappyStk`stk))
-}

-- Enter error recovery: generate an error token,
--                       save the old token and carry on.
happyFail  i tk (HappyState (action)) sts stk =
--      trace "entering error recovery" $
        action (1) (1) tk (HappyState (action)) sts ( (HappyErrorToken (i)) `HappyStk` stk)

-- Internal happy errors:

notHappyAtAll :: a
notHappyAtAll = error "Internal Happy error\n"

-----------------------------------------------------------------------------
-- Hack to get the typechecker to accept our action functions







-----------------------------------------------------------------------------
-- Seq-ing.  If the --strict flag is given, then Happy emits 
--      happySeq = happyDoSeq
-- otherwise it emits
--      happySeq = happyDontSeq

happyDoSeq, happyDontSeq :: a -> b -> b
happyDoSeq   a b = a `seq` b
happyDontSeq a b = b

-----------------------------------------------------------------------------
-- Don't inline any functions from the template.  GHC has a nasty habit
-- of deciding to inline happyGoto everywhere, which increases the size of
-- the generated parser quite a bit.

{-# LINE 322 "templates\\GenericTemplate.hs" #-}
{-# NOINLINE happyShift #-}
{-# NOINLINE happySpecReduce_0 #-}
{-# NOINLINE happySpecReduce_1 #-}
{-# NOINLINE happySpecReduce_2 #-}
{-# NOINLINE happySpecReduce_3 #-}
{-# NOINLINE happyReduce #-}
{-# NOINLINE happyMonadReduce #-}
{-# NOINLINE happyGoto #-}
{-# NOINLINE happyFail #-}

-- end of Happy Template.
