{-

APS
(C) Copyright Omar Saad Almousa 2014-2015

All Rights Reserved.

-}

{-# LANGUAGE DeriveDataTypeable #-}

module StrandAST where 
import Data.Typeable
import Data.Data
import Data.List
import Data.Maybe
--import qualified Data.Map as Map
import Data.Map
import Ast
import Msg
import Data.Maybe
data Strand = Strand {   name        :: String, -- protocol name  
                         owner       :: Ident, --Agent?
                         knowledge   :: SKnowledge,
                         --  fresh   :: SFresh,  -- maybe we need it later
                         rest        :: Strand0 } deriving (Eq)
                        
data Strand0    =  Snd Details Msg Strand0 
                |  Rcv Details Msg Strand0
                |  IF Fact Strand0 Strand0 Strand0
                |  OR Strand0 Strand0 Strand0
                |  Add Fact [String] Msg [Msg] Strand0
                |  Delete Fact Strand0
                |  Query Fact Strand0
----------------------------------------------------------
                |  Omar String Strand0  -- this has no reason, used only for testing
                |  Connects Strand0     -- connecting a list of strands to the a strand
------------ binders (:=) -----------
             --    |     Bind Msg Msg Strand0-- after Check or Rcv, we label the results of destructors: decrypt, open, get ....
                |  How Destructor Msg Msg Msg Strand0 -- to add a recipe (newMsg, key, oldMsg) and in case of format (newLabel, formatName, oldMsg )
-----------Checks (Verifiers and direct checks)------------------------
                |     V Verifier Msg Msg Strand0 -- verifiers  (col3)
            --    |     V VFsignH Msg Msg Msg Strand0 -- verifiers  (col3)
            --    |     Check Msg Msg Strand0 -- verify
                |     Create Msg Msg Msg Strand0 -- mainly for formats: new-label, format name, labelled format(msg?)
-------------------------- Fresh
                |  Fresh Type [Msg] [String] Strand0 -- the type followed by the fresh value/s
---------------------EOS
                |    EOS SessionId 
                -- deriving (Eq)                
               deriving (Eq, Show)                

data Destructor = Open | Get Int | Decrypt | Sdecrypt | Project Int | GetSignH deriving (Eq,Typeable,Data,Show,Ord)
data Verifier = Vsign | Vcrypt | Vscrypt | Vformat | Check | VSignH Msg | VFsignH  deriving (Eq,Typeable,Data,Show,Ord)

type Details = (Channel, Msg, Maybe Msg, Maybe Msg)
type SFresh       =    [Ident] -- Fresh knowledge per agent/ strand
type Fresh        =    (Ident, [Ident]) -- Agent fresh knowledge
type SKnowledge   =    [(Msg,Msg)] -- you can make it [(Msg, Msg,Type)] to implement a type system or at least handle types somehow
data Fact         =    Witness --    Ident Ident Msg ---improve this
                    |  Request    --Ident Ident Msg Msg
                    |  Wrequest --Ident Ident Msg Msg
                    |  Secrt --Msg Ident [Ident]
                    |  Contains --Ident Fact
                    |  Iknows --Msg 
                    -- Compositional Extension
                    |  InitKa -- Ident Ident Msg Msg
                    |  RespKa -- Ident Ident Msg Msg
                    deriving (Show,Eq)

type SessionId    =     Ident
------------------------------------------------------------------------------------------------------------
instance Show Strand where
  show (Strand n o k r) = n++"\n OWNER:"++o++"\n KNOWLEDGE:\n"++show (k) ++ "\n REST:\n" ++ show(r)
------------------------------------------------------------------------------------------------------------
-- Lighter pretty-printer for strands
strndPP (Strand n o k r) = n++"\n OWNER:"++o++"\n KNOWLEDGE:\n"++show (k) ++ "\n REST:\n" ++ strd0PP r
------------------------------------------------------------------------------------------------------------
{- CORRUPTED SHOW INSTANCE
instance Show Strand0 where
    show (Snd det m rest)         = "\t\t\t\t  |---SND---> "++ show(m) ++ "("++show(det)++")\n"++ show(rest)
    show (Rcv det m rest)         = "\t\t\t\t  |<--RCV---- "++ show(m) ++ "("++show(det)++")\n"++ show(rest)
    show (IF fct tb fb rest)    = "\t\t\t\t /\\   IF      "++ show(fct) ++ "\n\t True Branch\n\t" ++show(tb)++"\t\t\t False Branch \t\t\t"++ show(fb) ++"\n" ++ show(rest)
    show (OR lb rb rest)        = "\t\t\t\t /\\   OR      "++"\n\t Left Branch\n\t" ++show(lb)++"\t\t\t Right Branch \t\t\t"++ show(rb) ++"\n" ++ show(rest)
    show (Add fct s m ms rest)    = "\t\t\t\t  |   +       "++ show(fct) ++ "("++show(m)++ show(ms)++")["++ show(s)++"]\n"++show(rest)
    show (Delete fct rest)         = "\t\t\t\t  |   -       "++ show(fct) ++show(rest)
    show (Query fct rest)        = "\t\t\t\t  |   ?       "++ show(rest)
    show (Omar str rest)        = "\t\t\t\t  | omar      "++ str ++ show(rest)
    show (Connects rest)        = show(rest)
    show (How d m1 m2 m3 rest)    = "\t\t\t\t  | macro     "++ show(m1) ++ ":=" ++show(d) ++"("++ show(m2) ++ ")\t["++ show(m3) ++"]\n"++show(rest)
    show (V v m1 m2  rest)        = "\t\t\t\t  | check     "++ show(v)  ++"(" ++show(m1)++ ")==" ++show(m2) ++"\n"++show(rest)
    show (Create m1 m2 m3 rest)    = "\t\t\t\t  | format    "++ show(m1) ++"=" ++ show(m2) ++"("++show(m3)++ ")\n" ++show(rest)
    show (Fresh t ms m3 rest)    = "\t\t\t\t  | Fresh     "++ show(t) ++"  " ++ show(head ms) ++"("++show(m3)++ ")\n" ++
                                    if(tail ms /= []) then show(Fresh t (tail ms) m3 rest) else show(rest)
    show (EOS sess)                = "\t\t\t\t  - EOS       "++ sess++"\n\n"
-}
------------------------------------------------------------------------------------------------------------
-- Lighter pretty-printer for strands0
strd0PP (Snd det m rest)     = "\t\t\t\t  |---SND---> "++ show(m) ++ "\n"++ strd0PP(rest)
strd0PP (Rcv det m rest)     = "\t\t\t\t  |<--RCV---- "++ show(m) ++ "\n"++ strd0PP(rest)
strd0PP (IF fct tb fb rest)    = "\t\t\t\t /\\   IF      "++ show(fct) ++ "\n\t True Branch\n\t" ++show(tb)++"\t\t\t False Branch \t\t\t"++ show(fb) ++"\n" ++ strd0PP(rest)
strd0PP (OR lb rb rest)        = "\t\t\t\t /\\   OR      "++"\n\t Left Branch\n\t" ++strd0PP(lb)++"\t\t\t Right Branch \t\t\t"++ strd0PP(rb) ++"\n" ++ strd0PP(rest)
strd0PP (Add fct s m ms rst)= "\t\t\t\t  |   +       "++ show(fct) ++ "("++show(m)++ show(ms)++")\n"++strd0PP(rst)
strd0PP (Delete fct rest)     = "\t\t\t\t  |   -       "++ show(fct) ++"\n"++strd0PP(rest)
strd0PP (Query fct rest)    = "\t\t\t\t  |   ?       "++ show(fct) ++"\n"++strd0PP(rest)
strd0PP (Omar str rest)        = "\t\t\t\t  | omar      "++ str ++ "\n"++ strd0PP(rest)
strd0PP (Connects rest)        =                                     strd0PP(rest)
strd0PP (How d m1 m2 m3 rst)= "\t\t\t\t  | macro     "++ show(m1) ++ ":=" ++show(d) ++"("++ show(m2) ++ ")\n" ++strd0PP(rst)
strd0PP (V v m1 m2  rest)    = "\t\t\t\t  | check     "++ show(v)  ++"(" ++show(m1)++ ")==" ++show(m2) ++ "\n"++ strd0PP(rest)
strd0PP (Create m1 m2 m3 rs)= "\t\t\t\t  | format    "++ show(m1) ++"=" ++ show(m2) ++"("++show(m3)++ ")" ++ "\n" ++ strd0PP(rs)
strd0PP (Fresh t ms m3 rest)= "\t\t\t\t  | Fresh     "++ show(t) ++"  " ++ show(head ms) ++"("++show(m3)++ ")" ++ "\n" ++ 
                                    if(tail ms /= []) then strd0PP(Fresh t (tail ms) m3 rest) else strd0PP(rest)
strd0PP (EOS sess)        = "\t\t\t\t  - EOS       "++ sess     
 