{-

APS
(C) Copyright Omar Saad Almousa 2014-2015

All Rights Reserved.

-}
module ToAnB where
import Analyze
import ComposeM
import StrandAST
import Ast
import Msg
import GeneratePlainStrands
import OperationalStrands
import ToPv
import Data.List

anbs prot= anB prot  
--------------------------------------------
anB prot = "#Auto Generated by APS\tOmar Almousa(c)\nProtocol:"++ p_name prot ++ 
            "\nTypes:\n" ++ prntT (allIds prot) ++ 
            "\nKnowledge:\n" ++ 
            prntK (fst (p_know prot)) (rmvdups (map fst (concat(concat (getStrndsSigns (map rest (opStrands (generateStrands prot)))))))\\ basicOperators) ++
            (if (null (snd (p_know prot))) then "" else "where\n "++cnds (snd (p_know prot))) ++
            "\nActions:\n" ++ prntAs (p_acts prot)    ++
            "\nGoals:\n" ++ prntGs (p_goal prot) ++
            if (null (p_abst prot)) then "\n" else  "\nAbstractions:\n" ++ prntB (p_acts prot)
--------------------------------------------        
--thy prot= "NotDoneYet" -- basicThy ++ thyFormats (p_form prot)
--------------------------------------------
-- Simple projection for protocol -- this is supposed to be made in a better way! no time for reconstruction
p_name (a,b,c,d,e,f,g,h,i,j,k)=a
p_type (a,b,c,d,e,f,g,h,i,j,k)=b
p_maps (a,b,c,d,e,f,g,h,i,j,k)=c
p_form (a,b,c,d,e,f,g,h,i,j,k)=d
p_know (a,b,c,d,e,f,g,h,i,j,k)=e
p_macr (a,b,c,d,e,f,g,h,i,j,k)=f
p_acts (a,b,c,d,e,f,g,h,i,j,k)=g
p_goal (a,b,c,d,e,f,g,h,i,j,k)=h
p_priv (a,b,c,d,e,f,g,h,i,j,k)=i
p_resl (a,b,c,d,e,f,g,h,i,j,k)=j
p_abst (a,b,c,d,e,f,g,h,i,j,k)=k
--------------------------------------------
-- To get all identifiers, in types or as fresh!
allIds prot = p_type  prot ++ fresh (p_acts prot)
--------------------------------------------
fresh ((CreateFresh (ch, (t, lst))):xs)= (t,lst): fresh xs
fresh (x:xs) = fresh xs
fresh []=[]
--------------------------------------------
-- Types printer
prntT (x:y:xs)     =show(fst x) ++ " " ++  comSep(snd x)++";\n" ++ prntT (y:xs)
prntT [x]         =show(fst x) ++ " " ++  comSep(snd x)++"\n"
prntT []        ="\n" -- nonsense!
-------------------------------------------- 
-- Knowledge printer
prntK (x:y:xs) ops    =      (fst x) ++  ":" ++ comSep ((map show (snd x))++ops) ++";\n" ++ prntK (y:xs)    ops
prntK ([x])    ops    =    (fst x) ++  ":" ++ comSep ((map show(snd x))++ops)  ++"\n"  
prntK []       ops    =    "\n" -- nonsense! 
--------------------------------------------
cnds ([(a,b)]) = show a ++"!=" ++show b ++"\n"
cnds ((a,b):x:xs) = show a ++"!=" ++show b ++ ", " ++ cnds (x:xs)
--------------------------------------------
basicOperators=["crypt", "scrypt", "exp"]
--------------------------------------------
-- Actions Printer
prntAs (x:xs) = prntA x ++"\n" ++prntAs xs
prntAs [] = "\n"
--------------------------------------------
prntA (Exchange (ch,m1,m2,m3))= prntCh ch m1 --- we need to cover m2 and m3!!
prntA _ = ""
--------------------------------------------
prntCh ch m1 =     if (chT ch == Insecure)                 then (chP1 ch ++ " -> "     ++ chP2 ch ++ ": "++ show m1)
                    else if (chT ch == Authentic)         then (chP1 ch ++ " *-> "     ++ chP2 ch ++ ": "++ show m1)
                    else if (chT ch == Confidential)     then (chP1 ch ++ " ->* "     ++ chP2 ch ++ ": "++ show m1)
                    else if (chT ch == Secure)             then (chP1 ch ++ " *->* "     ++ chP2 ch ++ ": "++ show m1)
                    else if (chT ch == FreshAuthentic)     then (chP1 ch ++ " *-> "     ++ chP2 ch ++ ": "++ show m1) -- *->> 
                    else if (chT ch == FreshSecure)     then (chP1 ch ++ " *->* "     ++ chP2 ch ++ ": "++ show m1) -- *->>*
                    else (chP1 ch ++ " Hello There :)-- Something wrong!" )
--------------------------------------------
-- This needs to be updated for the psydonyms!
chP1 (a, b,c) = if(peerFlag a) then "["++ peerName a ++"]" else peerName a 
chT (a, b,c) = b
chP2 (a,b,c) = if(peerFlag c) then "["++ peerName c ++"]" else peerName c
--------------------------------------------
peerName (n,am, b,p) = n
peerFlag (n,am, b,p) = b
--------------------------------------------
-- Goals printer
prntGs (x:xs)= prntG x ++ "\n" ++prntGs xs
prntGs []= "\n"
-----------------------------------------------------------------------------------
prntG (ChGoal ch m) =             prntCh ch m
prntG (Secret m peers) =             show m ++ " secret between " ++ comSep (map peerName peers)
prntG (Authentication p1 p2 m) =     peerName p1 ++ " authenticates " ++ peerName p2 ++ " on " ++ show m
prntG (WAuthentication p1 p2 m) = peerName p1 ++ " weakly authenticates " ++ peerName p2 ++ " on " ++ show m
----------------------------------------------------------------------------------------
prntB x = show(x)
----------------------------------------------------------------------------------------