{-

APS
(C) Copyright Omar Saad Almousa 2014-2015

All Rights Reserved.

-}
module ToAnBf where
import Analyze
import ComposeM
import StrandAST
import Ast
import Msg
import GeneratePlainStrands
import OperationalStrands
import ToPv
import ToAnB
import Data.List

anbsf prot= anBf prot  -- (anB prot, thy prot)
--------------------------------------------
anBf prot = "#Auto Generated by APS\tOmar Almousa(c)\nProtocol:"++ p_name prot ++ 
            "\nTypes:\n" ++ prntT (allIds prot) ++ 
            "\nKnowledge:\n" ++ 
            prntKf (fst (p_know prot)) (rmvdups (map fst (concat(concat (getStrndsSigns (map rest (opStrands (generateStrands prot)))))))\\ basicOperators) ++
            (if (null (snd (p_know prot))) then "" else "where\n "++cndsf (snd (p_know prot))) ++
            "\nActions:\n" ++ prntAsf (p_acts prot)    ++
            "\nGoals:\n" ++ prntGsf (p_goal prot) ++
            if (null (p_abst prot)) then "\n" else  "\nAbstractions:\n" ++ prntB (p_acts prot)
--------------------------------------------        
-- Knowledge printer
prntKf (x:y:xs) ops    =      (fst x) ++  ":" ++ comSep ((map showf (snd x))++ops) ++";\n" ++ prntKf (y:xs) ops
prntKf ([x])    ops    =    (fst x) ++  ":" ++ comSep ((map showf(snd x))++ops)  ++"\n"  
prntKf []        ops    =    "\n" -- nonsense! 
--------------------------------------------
cndsf ([(a,b)]) = showf a ++"!=" ++showf b ++"\n"
cndsf ((a,b):x:xs) = showf a ++"!=" ++showf b ++ ", " ++ cndsf (x:xs)
--------------------------------------------
--------------------------------------------
-- Actions Printer
prntAsf (x:xs) = prntAf x ++"\n" ++prntAsf xs
prntAsf [] = "\n"
--------------------------------------------
prntAf (Exchange (ch,m1,m2,m3))= prntChf ch m1 --- we need to cover m2 and m3!
prntAf _ = ""
--------------------------------------------
prntChf ch m1 =  if (chT ch == Insecure)                 then (chP1 ch ++ " -> "     ++ chP2 ch ++ ": "++ showf m1)
                    else if (chT ch == Authentic)         then (chP1 ch ++ " *-> "     ++ chP2 ch ++ ": "++ showf m1)
                    else if (chT ch == Confidential)     then (chP1 ch ++ " ->* "     ++ chP2 ch ++ ": "++ showf m1)
                    else if (chT ch == Secure)             then (chP1 ch ++ " *->* "     ++ chP2 ch ++ ": "++ showf m1)
                    else if (chT ch == FreshAuthentic)     then (chP1 ch ++ " *-> "     ++ chP2 ch ++ ": "++ showf m1) -- *->> 
                    else if (chT ch == FreshSecure)     then (chP1 ch ++ " *->* "     ++ chP2 ch ++ ": "++ showf m1) -- *->>*
                    else (chP1 ch ++ " Hello There :)-- Something wrong!" )
--------------------------------------------
-- Goals printer
prntGsf (x:xs)= prntGf x ++ "\n" ++prntGsf xs
prntGsf []= "\n"
-------------------------------------------------------------------------
prntGf (ChGoal ch m) =             prntChf ch m
prntGf (Secret m peers) =             showf m ++ " secret between " ++ comSep (map peerName peers)
prntGf (Authentication p1 p2 m) =     peerName p1 ++ " authenticates " ++ peerName p2 ++ " on " ++ showf m
prntGf (WAuthentication p1 p2 m) = peerName p1 ++ " weakly authenticates " ++ peerName p2 ++ " on " ++ showf m
--------------------------------------------