{-

APS
(C) Copyright Omar Almousa 2014-2015

All Rights Reserved.

-}
module ToJS where
import Analyze
import ComposeM
import StrandAST
import Msg
import Ast
import Preprocessor
import OperationalStrands
import GeneratePlainStrands
import Data.List
import Data.List.Split

------------
toJSs []= ""
toJSs  (x:xs)=   (toJS x) ++ (toJSs xs)
----------------------------------------------------------------------------
toJS s@(Strand n o know rest)= (header n o know) ++ (toJS0 [] rest)
------------------------------------------------------
--- checked is to eliminate duplicated and redundant checks produced from calling analyze several time!
-- [Strand0] ->Strand0-> String
toJS0 checked (Snd det m rest) = if(hasAnno m) then "ch.send(" ++ (getIdentAnno m)++ ");\n"++ (toJS0 checked rest)
                                    else "ch.send(" ++ (getIdentSnd m)++ ");\n"++ (toJS0 checked rest)
toJS0 checked (Rcv det m rest) = "var " ++ (getIdent m) ++ " = ch.receive();\n" ++ (toJS0 checked rest)

toJS0 checked s@(V Check m1 m2 rest)     =  if (elem ("Check",m1,m2) checked || elem ("Check",m2,m1) checked) 
                                            then toJS0 checked rest 
                                            else "if(" ++ (getIdent m1)++ " != " ++ (getIdent m2) ++ ") error();\n" ++ 
                                                        (toJS0 (("Check",m1,m2):checked) rest)
toJS0 checked s@(V VFsignH m l rest)     = "FSignH "++ getIdent l++"a = new FSignH("++getIdent l++");\n"++toJS0 checked  rest
toJS0 checked s@(V ver m1 m2 rest)     =  toJS0 checked  rest
toJS0 checked (How (Get n) m1 m2 m3 rest) = "var "++ (getIdent m1) ++ " = " ++ (getIdent m3) ++ "a.get" ++ show(n) ++ "();\n" ++ 
                                                (toJS0 checked rest)
toJS0 checked (How GetSignH m1 m2 m3 rest) = "var "++ (getIdent m1) ++ " = " ++ (getIdent m3) ++ "a.getMessage();\n" ++ (toJS0 checked rest)
toJS0 checked (How (Project n) m1 m2 m3 rest) = "var "++ (getIdent m1) ++ " = proj" ++ show(n)++ "("  ++ (getIdent m2) ++
                                                    ");\n" ++ (toJS0 checked rest)
toJS0 checked (How des m1 m2 m3 rest)=  if(elem ("Open",m2,m3) checked) then toJS0 checked rest 
                                            else "var "++ (getIdent m1) ++ " = " ++ (lowerize (show(des)))++"(" ++ (getIdent m2)++ ", " ++ 
                                                (getIdent m3)++");\n" ++ (toJS0 (("Open",m2,m3):checked) rest)
toJS0 checked (Create m1 m2 m3 rest)= (getIdent m3) ++" " ++(getIdent m1) ++ "a = new "++ (getIdent m3)++ "("++(getIdent m2)++
                                                ");\n" ++(toJS0 checked rest)
toJS0 checked (Add event id m ps rest)= "" ++ (toJS0 checked rest)
toJS0 checked (Fresh typ ms orms rest)= if(getAnnot typ /= []) then annot (cleanAnnot . getAnnot $typ) (head ms) ++ decFresh 1 typ (head ms) ms ++ (toJS0 checked rest)
                                            else decFresh 0 typ (head ms) ms ++ (toJS0 checked rest)
toJS0 checked (EOS _)                 =  "}\n //#"
------------------------------------------------------------------
-- takes a type annotation  and a 
annot typ h = "annot an"++ (getIdent h) ++  "={" ++ lstEq typ ++ "};\n"
lstEq [(a,b)] = a ++ " = " ++ (getIdent b)
lstEq ((a,b):rst) = (a ++ " = " ++ (getIdent b) ++ ", ") ++ lstEq rst
------------------------------------------------------------------
decFresh 1 typ h []=""
decFresh 1 typ h (m:rst)= (prnType typ) ++"  "++ (getIdent m) ++ " = gen" ++ (prnType typ)++ "(an"++ (getIdent h) ++");\n"
decFresh 0 typ h []=""
decFresh 0 typ h (m:rst)= (prnType typ) ++"  "++ (getIdent m) ++ " = gen" ++ (prnType typ) ++ "();\n"
------------------------------------------------------------------
------------------------------------------------------------------
header n o k= "//Auto-Generated Code by APS2Java\n\n\n//Agent  "++ o ++" function in protocol:"++ n ++"  is  \nfunction prog_"++ o ++"_"++n++"("++ (paramz k) ++", Channel ch){\n" 
--------------------------------------------------------------
params []  = ""
params [(a,b)] = (typeOf b) ++ " "++ (getIdent a)
params ((a,b):y:z) =(typeOf b) ++ " " ++ (getIdent a) ++"," ++ (params(y:z))
paramz a= params  a
--------------------------
typeOf m= ""
------------------------------------------------
cleanString st = [ c | c <- st, c /= '/' && c/= '"' ]
--------------------------------
hasAnno (Atom _)= False
hasAnno (Comp Apply opt lst)= if(null opt) then (or (map hasAnno lst)) else True
hasAnno (Comp Cat opt lst)= if(null opt) then (or (map hasAnno lst)) else True
hasAnno (Comp op opt lst)= if(null opt) then (or (map hasAnno lst)) else True
---------------------------------------------------------------------------------
getIdentAnno (Atom ('f':'r':'m':rst))= rst
getIdentAnno (Atom ('m':'p':'p':rst))= rst
getIdentAnno (Atom x)= x
getIdentAnno (Comp Apply opt ((Atom ('f':'r':'m':rst)):xs))= rst++"(" ++(getIdentsSnd xs)++")"
getIdentAnno (Comp Apply opt (x:xs))= (getIdentSnd x) ++ "(" ++ (getIdentsSnd xs)++")"
getIdentAnno (Comp Cat opt ls)= "(" ++ (getIdentsSnd ls)++")"
getIdentAnno (Comp op opt ls)= lowerize (show(op)) ++"({" ++ lstEq (cleanAnnot opt) ++ "},"++(getIdentsSnd ls)++")"
----------------------------------------------------------------
getIdentSnd (Atom ('f':'r':'m':rst))= "new " ++ rst
getIdentSnd (Atom ('m':'p':'p':rst))= rst
getIdentSnd (Atom x)= x
getIdentSnd (Comp Apply opt ((Atom ('f':'r':'m':rst)):xs))= "new " ++ rst++"(" ++(getIdentsSnd xs)++").encode()"
getIdentSnd (Comp Apply opt (x:xs))= (getIdentSnd x) ++ "(" ++ (getIdentsSnd xs)++")"
getIdentSnd (Comp Cat opt ls)= "(" ++ (getIdentsSnd ls)++")"
getIdentSnd (Comp op opt ls)= lowerize (show(op)) ++ "(" ++ (getIdentsSnd ls)++")"
--------------------------------------------------------------
getIdentsSnd []=" "
getIdentsSnd [x]= getIdentSnd x
getIdentsSnd (x:y:z)= (getIdentSnd x) ++ ", " ++ (getIdentsSnd (y:z))